﻿<?php

require_once dirname(__FILE__).'/../lib/commandeGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/commandeGeneratorHelper.class.php';

/**
 * commande actions.
 *
 * @package    sf_sandbox
 * @subpackage commande
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class commandeActions extends autoCommandeActions
{
	public function executeEdit(sfWebRequest $request)
	{
		$this->commande = $this->getRoute()->getObject();
		$this->commande->setPoidsTotal(Utils::doubleEnToFr($this->commande->getPoidsTotal()));
		$this->commande->setFraisPortHt(Utils::doubleEnToFr($this->commande->getFraisPortHt()));
		$this->commande->setTotalProduitHt(Utils::doubleEnToFr($this->commande->getTotalProduitHt()));
		$this->commande->setTotalHt(Utils::doubleEnToFr($this->commande->getTotalHt()));
		$this->commande->setTauxTva(Utils::doubleEnToFr($this->commande->getTauxTva()));
		$this->commande->setTotalTtc(Utils::doubleEnToFr($this->commande->getTotalTtc()));

		$this->form = $this->configuration->getForm($this->commande);

		// On récupère le détails de la commande
		$this->commandeArticles = Doctrine_Core::getTable("CommandeArticle")->findByIdCommande($this->commande->getIdCommande());
	}

	public function executeNew(sfWebRequest $request)
	{
		$this->form = $this->configuration->getForm();
		$this->commande = $this->form->getObject();

		$this->commandeArticles = array();
	}

	public function executeCreate(sfWebRequest $request)
	{
		if($request->isXmlHttpRequest())
		{
			$result = array();
			$token = uniqid();
			$file = $_FILES['commande'];
				
			$extensions = array('.pdf');
			$extension = strrchr($file['name']['devis_pdf'][0], '.');
				
			if(!in_array($extension, $extensions))
			{
				$result[0]['resultat'] = false;
				$result[0]['message'] = "Vous devez choisir un fichier de type pdf !";
				return $this->renderText($result);
			}
			else
			{
				if(move_uploaded_file($file['tmp_name']['devis_pdf'][0], sfConfig::get('commande_pdf_devis_dir')."/".$token.$extension))
				{
					$result[0]['name'] = $file['name']['devis_pdf'][0];
					$result[0]['url'] = sfConfig::get('app_url_pdf_devis')."/".$token.$extension;
					$result[0]['delete_url'] = sfConfig::get('app_url_pdf_devis')."/".$token.$extension;
					$result[0]['nom_fichier'] = $token.$extension;
					$result[0]['resultat'] = true;
					$result[0]['token'] = $token;
				}
				else
				{
					$result[0]['resultat'] = false;
					$result[0]['message'] = "Erreur danns le téléchargement du fichier !";
					$result[0]['test'] = sfConfig::get('commande_pdf_devis_dir');
				}
			}
				
			return $this->renderText(json_encode($result));
		}
		else
		{
			$this->form = $this->configuration->getForm();
				
			$this->commande = $this->form->getObject();

			$this->commandeArticles = array();
				
			$this->processForm($request, $this->form);

			$this->setTemplate('new');
		}
	}

	public function executeUpdate(sfWebRequest $request)
	{
		if($request->isXmlHttpRequest())
		{
			$result = array();
			$token = uniqid();
			$file = $_FILES['commande'];
				
			$extensions = array('.pdf');
			$extension = strrchr($file['name']['devis_pdf'][0], '.');
				
			if(!in_array($extension, $extensions))
			{
				$result[0]['resultat'] = false;
				$result[0]['message'] = "Vous devez choisir un fichier de type pdf !";
				return $this->renderText($result);
			}
			else
			{
				if(move_uploaded_file($file['tmp_name']['devis_pdf'][0], sfConfig::get('commande_pdf_devis_dir')."/".$token.$extension))
				{
					$result[0]['name'] = $file['name']['devis_pdf'][0];
					$result[0]['url'] = sfConfig::get('app_url_pdf_devis')."/".$token.$extension;
					$result[0]['delete_url'] = sfConfig::get('app_url_pdf_devis')."/".$token.$extension;
					$result[0]['nom_fichier'] = $token.$extension;
					$result[0]['resultat'] = true;
					$result[0]['token'] = $token;
				}
				else
				{
					$result[0]['resultat'] = false;
					$result[0]['message'] = "Erreur danns le téléchargement du fichier !".sfConfig::get('commande_pdf_devis_dir');
					$result[0]['test'] = sfConfig::get('commande_pdf_devis_dir');
				}
			}
				
			return $this->renderText(json_encode($result));
		}
		else
		{
			$this->commande = $this->getRoute()->getObject();
			$this->form = $this->configuration->getForm($this->commande);

			$this->commandeArticles = array();
				
			$this->processForm($request, $this->form);
				
			$this->setTemplate('edit');
		}
	}

	protected function processForm(sfWebRequest $request, sfForm $form)
	{
		$values = $request->getParameter($form->getName());
		$valuesFile = $request->getFiles($form->getName());

		$tva = Doctrine_Core::getTable("TauxTVA")->find(sfConfig::get('app_tva_196'));

		$commandeTemp = new Commande();
		if($values['id_commande'] != "")
		{
			$commandeTemp = Doctrine_Core::getTable("Commande")->find($values['id_commande']);
		}

		/*if($this->getUser()->hasCredential('Commercial'))
		{*/
			if($values['id_commande'] == "")
			{
				$values['id_user_suiveur'] = $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser');
			}
			/*else
			{
				if($commandeTemp->getIdUserSuiveur() != $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'))
				{
					$this->forward('sfGuardAuth', 'secure');
					exit;
				}
			}*/
		//}

		$values['poids_total'] = Utils::doubleFrToEn($values['poids_total']);
		$values['frais_port_ht'] = Utils::doubleFrToEn($values['frais_port_ht']);
		$values['total_produit_ht'] = Utils::doubleFrToEn($values['total_produit_ht']);
		$values['total_ht'] = Utils::doubleFrToEn($values['total_ht']);
		$values['taux_tva'] = Utils::doubleFrToEn($values['taux_tva']);
		$values['total_ttc'] = Utils::doubleFrToEn($values['total_ttc']);

		if($values['devis_token'] != "")
		{
			$values['devis_pdf'] = $values['devis_token'].".pdf";
		}
		if($values['type_commande'] == 2)
		{
			if(sizeof($request->getParameter('article')) > 0)
			{
				$articles = new Doctrine_Collection("CommandeArticle");
				foreach($request->getParameter('article') as $_article)
				{
					if(is_numeric($_article['quantite']) && $_article['quantite'] > 0)
					{
						$article = Doctrine::getTable("Article")->find($_article['reference']);
						$nettoyeur = null;
						if(!($article instanceof Article))
						{
							$nettoyeur = Doctrine::getTable("NettoyeurHautePression")->findOneByReferenceThs($_article['reference']);
						}

						if(($article instanceof Article) || ($nettoyeur instanceof NettoyeurHautePression))
						{
							$commande_article = new CommandeArticle();

							$prix_unitaire_ht = 0;
							$prix_total_ht = 0;
							$prix_total_ttc = 0;
							if($article instanceof Article)
							{
								$commande_article->setIdArticle($_article['reference']);
								$prix_unitaire_ht = $article->getPrixVenteThs();
							}

							if($nettoyeur instanceof NettoyeurHautePression)
							{
								$commande_article->setIdNettoyeur($nettoyeur->getIdNettoyeur());
								$prix_unitaire_ht = $nettoyeur->getPrixVenteThs();
							}
							$prix_total_ht = $prix_unitaire_ht * $_article['quantite'];
							$prix_total_ttc = round($prix_total_ht * (1 + $tva->getTaux() / 100), 2);

							$commande_article->setQuantite($_article['quantite']);
							$commande_article->setPrixUnitaireHt($prix_unitaire_ht);
							$commande_article->setPrixTotalHt($prix_total_ht);
							$commande_article->setPrixTotalTtc($prix_total_ttc);
							$articles->add($commande_article);
						}
					}
				}
				$this->commandeArticles = $articles;
				$values['commande_token'] = uniqid();
			}
		}
		else if($values['type_commande'] == 3)
		{
			$values['devis_token'] = uniqid();
		}

		$form->bind($values, $valuesFile);

		if($form->isValid())
		{
			$notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

			if($values['devis_token'] != "")
			{
				$values['devis_pdf'] = $values['devis_token'].".pdf";
			}
			if($values['type_commande'] == 2)
			{
				$values['commande_token'] = uniqid();
			}
			$form->bind($values, $valuesFile);

			try
			{
				$commande = $form->save();
					
				if($form->getValue('devis_pdf_supprimer'))
				{
					unlink(sfConfig::get("commande_pdf_devis_dir").DIRECTORY_SEPARATOR.$commande->getDevisPdf());
					$commande->setDevisToken("");
					$commande->setDevisPdf("");
					$commande->save();
				}

				if($commande->getEmail() != "" && $commandeTemp->getIdStatut() == sfConfig::get("app_commande_statut_cree") && $commande->getMailCommande() == false)
				{
					// Envoi du mail au client
					if($values['type_commande'] == 1)
					{
						$mail = Doctrine_Core::getTable("Mail")->find(sfConfig::get("app_mail_devis"));

						if($mail instanceof Mail)
						{
							$url = "<a href='http://www.haute-pression.com/devis/".$commande->getIdCommande()."/".$commande->getDevisToken().".html'>http://www.haute-pression.com/devis/".$commande->getIdCommande()."/".$commande->getDevisToken().".html</a>";
			
							$body = $mail->getMail();
							$body = str_replace("[LIEN_DEVIS]", $url, $body);
							
							$message = Swift_Message::newInstance()
							->setSubject($mail->getObjet())
							->setFrom(array(sfConfig::get("app_paiement_email") => 'Haute pression'))
							->setTo(array($commande->getEmail() => $commande->getEmail()))
							->setBcc(array('yenkong@lybliamay.fr' => 'Haute pression'))
							->setBody(MailTable::entete().$body, 'text/html');
	
							$this->getMailer()->send($message);
						}
					}
					else if($values['type_commande'] == 2)
					{
						$mail = Doctrine_Core::getTable("Mail")->find(sfConfig::get("app_mail_panier"));

						if($mail instanceof Mail)
						{
							$url = "<a href='http://www.haute-pression.com/commande/".$commande->getIdCommande()."/".$commande->getCommandeToken().".html'>http://www.haute-pression.com/commande/".$commande->getIdCommande()."/".$commande->getCommandeToken().".html</a>";
				
							$body = $mail->getMail();
							$body = str_replace("[LIEN_PANIER]", $url, $body);
								
							$message = Swift_Message::newInstance()
							->setSubject($mail->getObjet())
							->setFrom(array(sfConfig::get("app_paiement_email") => 'Haute pression'))
							->setTo(array($commande->getEmail() => $commande->getEmail()))
							->setBcc(array('yenkong@lybliamay.fr' => 'Haute pression'))
							->setBody(MailTable::entete().$body, 'text/html');
	
							$this->getMailer()->send($message);
						}
					}
					else if($values['type_commande'] == 3)
					{
						$mail = Doctrine_Core::getTable("Mail")->find(sfConfig::get("app_mail_ticket"));

						if($mail instanceof Mail)
						{
							$body = $mail->getMail();
							$body = str_replace("[PRIX]", $values['total_ttc'], $body);
							
							$url = "<a href='http://www.haute-pression.com/devis/".$commande->getIdCommande()."/".$commande->getDevisToken().".html'>http://www.haute-pression.com/devis/".$commande->getIdCommande()."/".$commande->getDevisToken().".html</a>";
							$body = str_replace("[LIEN_DEVIS]", $url, $body);
								
							$message = Swift_Message::newInstance()
							->setSubject($mail->getObjet())
							->setFrom(array(sfConfig::get("app_paiement_email") => 'Haute pression'))
							->setTo(array($commande->getEmail() => $commande->getEmail()))
							->setBcc(array('yenkong@lybliamay.fr' => 'Haute pression'))
							->setBody(MailTable::entete().$body, 'text/html');
	
							$this->getMailer()->send($message);
						}
					}
					$commande->setMailCommande(true);
				}
				
				// Envoi mail numéro colissimo
				if($values['numero_colissimo'] != "" && $commande->getMailColissimo() == false)
				{
					$mail = Doctrine_Core::getTable("Mail")->find(sfConfig::get("app_mail_colissimo"));

					if($mail instanceof Mail)
					{
						$url = "<a href='http://www.colissimo.fr/portail_colissimo/suivre.do?colispart=".$commande->getNumeroColissimo()."'>".$commande->getNumeroColissimo()."</a>";
			
						$body = $mail->getMail();
						$body = str_replace("[COLISSIMO]", $url, $body);
							
						$message = Swift_Message::newInstance()
						->setSubject($mail->getObjet())
						->setFrom(array(sfConfig::get("app_paiement_email") => 'Haute pression'))
						->setTo(array($commande->getEmail() => $commande->getEmail()))
						->setBcc(array('yenkong@lybliamay.fr' => 'Haute pression'))
						->setBody(MailTable::entete().$body, 'text/html');

						$this->getMailer()->send($message);

						$commande->setMailColissimo(true);
						$commande->setIdStatut(sfConfig::get("app_commande_statut_expedie"));
					}
				}

				// Enregistrement du panier si le statut est à créé
				if($values['commande_token'] != "" && ($commandeTemp->getIdCommande() == "" || $commandeTemp->getIdStatut() == sfConfig::get("app_commande_statut_cree")))
				{
					if($values['id_commande'] != "")
					{
						CommandeTable::supprimerArticle($values['id_commande']);
					}

					$poids = 0;
					$total_produit_ht = 0;
					$total_ttc = 0;
					foreach($request->getParameter('article') as $_article)
					{
						if(is_numeric($_article['quantite']) && $_article['quantite'] > 0)
						{
							$article = Doctrine::getTable("Article")->find($_article['reference']);
							$nettoyeur = null;
							if(!($article instanceof Article))
							{
								$nettoyeur = Doctrine::getTable("NettoyeurHautePression")->findOneByReferenceThs($_article['reference']);
							}

							if(($article instanceof Article) || ($nettoyeur instanceof NettoyeurHautePression))
							{
								$commande_article = new CommandeArticle();
								$commande_article->setIdCommande($commande->getIdCommande());

								$prix_unitaire_ht = 0;
								$prix_total_ht = 0;
								$prix_total_ttc = 0;
								if($article instanceof Article)
								{
									$commande_article->setIdArticle($_article['reference']);
									$prix_unitaire_ht = $article->getPrixVenteThs();
									$poids = str_replace(",", ".", $article->getPoids()) * $_article['quantite'];
								}

								if($nettoyeur instanceof NettoyeurHautePression)
								{
									$commande_article->setIdNettoyeur($nettoyeur->getIdNettoyeur());
									$prix_unitaire_ht = $nettoyeur->getPrixVenteThs();
									$poids = str_replace(",", ".", $nettoyeur->getPoids()) * $_article['quantite'];
								}
								$prix_total_ht = $prix_unitaire_ht * $_article['quantite'];
								$prix_total_ttc = round($prix_total_ht * (1 + $tva->getTaux() / 100), 2);

								$commande_article->setQuantite($_article['quantite']);
								$commande_article->setPrixUnitaireHt($prix_unitaire_ht);
								$commande_article->setPrixTotalHt($prix_total_ht);
								$commande_article->setPrixTotalTtc($prix_total_ttc);
								$commande_article->save();


								$total_produit_ht += $prix_total_ht;
								$total_ttc += $prix_total_ttc;
							}
						}
					}

					$commande->setPoidsTotal($poids);
					$commande->setTotalProduitHt($total_produit_ht);
					$commande->setTotalHt($total_produit_ht);
					$commande->setTauxTva($tva->getTaux());
					$commande->setTotalTtc($total_ttc);
				}
				$commande->save();
			}
			catch (Doctrine_Validator_Exception $e)
			{
				$errorStack = $form->getObject()->getErrorStack();

				$message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
				foreach ($errorStack as $field => $errors) {
					$message .= "$field (" . implode(", ", $errors) . "), ";
				}
				$message = trim($message, ', ');

				$this->getUser()->setFlash('error', $message);
				return sfView::SUCCESS;
			}

			$this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $commande)));

			if ($request->hasParameter('_save_and_add'))
			{
				$this->getUser()->setFlash('notice', $notice.' You can add another one below.');

				$this->redirect('@commande_new');
			}
			else
			{
				$this->getUser()->setFlash('notice', $notice);

				$this->redirect(array('sf_route' => 'commande_edit', 'sf_subject' => $commande));
			}
		}
		else
		{
			//$values['commande_token'] = "";
			$form->bind($values, $valuesFile);
			$this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
		}
	}
}
