<?php use_helper('I18N', 'Number') ?>
<?php use_stylesheet('/sfDoctrinePlugin/css/global.css', 'first') ?> 
<?php use_stylesheet('/sfDoctrinePlugin/css/default.css', 'first') ?> 
<?php $tauxTVA = Doctrine::getTable("TauxTVA")->find(sfConfig::get('app_tva_196'))->getTaux()?>
<div id="sf_admin_container">
  	<h1><?php echo __('Calcul des frais de port', array(), 'messages') ?></h1>

  	<?php if ($sf_user->hasFlash('notice')): ?>
  		<div class="notice"><?php echo __($sf_user->getFlash('notice'), array(), 'sf_admin') ?></div>
	<?php endif; ?>

	<?php if ($sf_user->hasFlash('error')): ?>
  		<div class="error"><?php echo __($sf_user->getFlash('error'), array(), 'sf_admin') ?></div>
	<?php endif; ?>

  <div id="sf_admin_content">
  	<div class="sf_admin_form">
		<?php echo form_tag( '@fraisdeport_calcul') ?>
	    	<?php echo $form->renderHiddenFields(false) ?>
	
	    	<?php if ($form->hasGlobalErrors()): ?>
	      		<?php echo $form->renderGlobalErrors() ?>
	    	<?php endif; ?>
	
			<fieldset id="fieldset_none">
				<?php echo $form["_csrf_token"]->render() ?>
				<div class="sf_admin_form_row">
					<?php echo $form["poids"]->renderError() ?>
					<div>
						<?php echo $form["poids"]->renderLabel() ?>
						<div class="content">
							<?php echo $form["poids"]->render(array("value"=>Utils::doubleEnToFr($form["poids"]->getValue()))) ?>
						</div>
					</div>
				</div>
				<div class="sf_admin_form_row">
					<?php echo $form["hors_gabarit"]->renderError() ?>
					<div>
						<?php echo $form["hors_gabarit"]->renderLabel() ?>
						<div class="content">
							<?php 
								$hors_gabarit_attributes = array();
								if($form["hors_gabarit"]->getValue() == 'on')
								{
									$hors_gabarit_attributes["checked"] = "checked";
								}
							?>
							<?php echo $form["hors_gabarit"]->render($hors_gabarit_attributes) ?>
						</div>
					</div>
				</div>
				<div class="sf_admin_form_row">
					<?php echo $form["code_postal"]->renderError() ?>
					<div>
						<?php echo $form["code_postal"]->renderLabel() ?>
						<div class="content">
							<?php echo $form["code_postal"]->render(array('maxlength' => 5)) ?>
						</div>
					</div>
				</div>
	   		</fieldset>
	   		<ul class="sf_admin_actions">
				<li>
					<input type="submit" name="btnSubmit" value="Calculer" />
				</li>
			</ul>
	  </form>
	</div>
    <div class="sf_admin_list">
    	<?php if(isset($resultats)):?>
    		<?php if(sizeof($resultats) == 0):?>
    			Aucun tarif n'est disponible pour ces caractéristiques
    		<?php else:?>
    			<h3>Tarif préférentiel :</h3>
    			<table id="CalculFraisPort">
    				<thead>
	    				<tr>
		    				<th class="sf_admin_list_th_actions">Transporteur</th>
		    				<th class="sf_admin_list_th_actions">Tarif HT</th>
		    				<th class="sf_admin_list_th_actions">Supplément emballage</th>
		    				<th class="sf_admin_list_th_actions">Total HT</th>
		    				<th class="sf_admin_list_th_actions">Tarif TTC</th>
		    			</tr>
	    			</thead>
	    			<tbody>
	    				<?php $tarif = $resultats[0]?>
	    				<tr>
	    					<td><?php echo $tarif->getZone()->getTransporteur()->getLibelle()?></td>
	    					<td><?php echo format_currency($tarif->getTarif())?></td>
	    					<td><?php echo format_currency($tarif->getZone()->getTransporteur()->getForfaitEmballage())?></td>
	    					<td><?php echo format_currency($tarif->getZone()->getTransporteur()->getForfaitEmballage() + $tarif->getTarif())?></td>
	    					<td><?php echo format_currency(($tarif->getZone()->getTransporteur()->getForfaitEmballage() + $tarif->getTarif()) * (1 + $tauxTVA / 100))?></td>
	    				</tr>
    				</tbody>
    			</table>
    			<?php if(sizeof($resultats) > 1):?>
	    			<h3>Autres suggestions :</h3>
	    			<table>
	    				<thead>
		    				<tr>
			    				<th class="sf_admin_list_th_actions">Transporteur</th>
			    				<th class="sf_admin_list_th_actions">Tarif HT</th>
			    				<th class="sf_admin_list_th_actions">Supplément emballage</th>
			    				<th class="sf_admin_list_th_actions">Total HT</th>
			    				<th class="sf_admin_list_th_actions">Tarif TTC</th>
			    			</tr>
		    			</thead>
		    			<tbody>
		    				<?php for($i = 1; $i < sizeof($resultats); $i++):?>
		    					<?php $tarif = $resultats[$i]?>
			    				<tr>
			    					<td><?php echo $tarif->getZone()->getTransporteur()->getLibelle()?></td>
			    					<td><?php echo format_currency($tarif->getTarif())?></td>
			    					<td><?php echo format_currency($tarif->getZone()->getTransporteur()->getForfaitEmballage())?></td>
			    					<td><?php echo format_currency($tarif->getZone()->getTransporteur()->getForfaitEmballage() + $tarif->getTarif())?></td>
			    					<td><?php echo format_currency(($tarif->getZone()->getTransporteur()->getForfaitEmballage() + $tarif->getTarif()) * (1 + $tauxTVA / 100))?></td>
			    				</tr>
		    				<?php endfor?>
	    				</tbody>
	    			</table>
	    		<?php endif;?>
    		<?php endif?>
    	<?php endif?>
    </div>
  </div>
</div>