<?php use_helper('I18N', 'Date') ?>
<?php include_partial('fraisdeport/assets') ?>

<div id="sf_admin_container">
	<h1><?php echo __('Edition du transporteur %%libelle%%', array('%%libelle%%' => $transporteur->getLibelle()), 'messages') ?></h1>
  	<?php include_partial('fraisdeport/flashes') ?>
  	<div id="sf_admin_header">
    	<?php include_partial('fraisdeport/form_header', array('transporteur' => $transporteur, 'form' => $form, 'configuration' => $configuration)) ?>
  	</div>
  	<div id="sf_admin_content">
    	<?php include_partial('fraisdeport/form', array('transporteur' => $transporteur, 'form' => $form, 'configuration' => $configuration, 'helper' => $helper)) ?>
  	</div>
  	<div id="sf_admin_footer">
    	<?php include_partial('fraisdeport/form_footer', array('transporteur' => $transporteur, 'form' => $form, 'configuration' => $configuration)) ?>
  	</div>
  	
  	<h1><?php echo __('Gestion des zones', null, 'messages') ?></h1>
  	<?php if ($sf_user->hasFlash('notice_zone')): ?>
  		<div class="notice"><?php echo __($sf_user->getFlash('notice_zone'), array(), 'sf_admin') ?></div>
	<?php endif; ?>
	<?php if ($sf_user->hasFlash('error_zone')): ?>
  		<div class="error"><?php echo __($sf_user->getFlash('error_zone'), array(), 'sf_admin') ?></div>
	<?php endif; ?>

  	<div id="sf_admin_content">
    	<?php if(sizeof($listeZone) == 0):?>
  			<p>Aucun résultat.</p>
  		<?php else:?>
    		<div class="sf_admin_list">
      			<table cellspacing="0">
      				<thead>
        				<tr>
          					<th class="sf_admin_text sf_admin_list_th_id_zone">
      							Id zone
      						</th>
							<th class="sf_admin_text sf_admin_list_th_libelle">
      							Libelle
      						</th>
							<th class="sf_admin_boolean sf_admin_list_th_statut">
      							Statut
      						</th>
          					<th id="sf_admin_list_th_actions">Actions</th>
        				</tr>
      				</thead>
      				<tfoot>
        				<tr>
          					<th colspan="6"><?php echo sizeof($listeZone)?> résultat<?php if(sizeof($listeZone) > 1):?>s<?php endif?></th>
        				</tr>
      				</tfoot>
      				<tbody>
      					<?php foreach($listeZone as $_zone):?>
	                  		<tr class="sf_admin_row odd">
	            				<td class="sf_admin_text sf_admin_list_td_id_zone">
	  								<?php echo $_zone->getIdZone()?>
	  							</td>
								<td class="sf_admin_text sf_admin_list_td_libelle"><?php echo $_zone->getLibelle()?></td>
								<td class="sf_admin_boolean sf_admin_list_td_statut">
									<?php if($_zone->getStatut()):?>
										<?php echo image_tag("sfDoctrinePlugin/tick.png", array("title" => "Checked", "alt" => "Checked"))?>
	    							<?php endif?>
	    						</td>
	            				<td>
	  								<ul class="sf_admin_td_actions">
	    								<li class="sf_admin_action_edit"><a href="<?php echo url_for("@edit_zone?id_transporteur=".$transporteur->getIdTransporteur()."&id_zone=".$_zone->id_zone."&mode=update")?>">Modifier</a></li>
	    								<li class="sf_admin_action_delete"><a href="<?php echo url_for("@edit_zone?id_transporteur=".$transporteur->getIdTransporteur()."&id_zone=".$_zone->id_zone."&mode=delete")?>" onclick="return confirm('Etes vous sûr ?')">Supprimer</a></li>
	    							</ul>
								</td>
	          				</tr>
          				<?php endforeach;?>
              		</tbody>
    			</table>
  			</div>
		<?php endif?>
    		<ul class="sf_admin_actions">
      			<li class="sf_admin_action_new"><a href="<?php echo url_for("@transporteur_fraisdeport_edit?id_transporteur=".$transporteur->getIdTransporteur())?>">Nouveau</a></li>
      		</ul>
	   	
	   	<form action="<?php echo url_for("@add_zone?id_transporteur=".$transporteur->getIdTransporteur())?>" method="post">
	   		<input type="hidden" id="zone_id_zone" name="zone[id_zone]" value="<?php echo $zone->getIdZone()?>">
	   		<input type="hidden" id="zone_id_transporteur" name="zone[id_transporteur]" value="<?php echo $transporteur->getIdTransporteur()?>">
			<fieldset id="sf_fieldset_none">
				<div class="sf_admin_form_row sf_admin_text sf_admin_form_field_libelle">
        			<div>
      					<label for="zone_libelle">Libelle</label>
      					<div class="content"><input type="text" id="zone_libelle" name="zone[libelle]" value="<?php echo $zone->getLibelle()?>"></div>
					</div>
  				</div>
            	<div class="sf_admin_form_row sf_admin_boolean sf_admin_form_field_statut">
 					<div>
      					<label for="zone_statut">Statut</label>
      					<div class="content"><input type="checkbox" id="zone_statut" <?php if($zone->getStatut()):?>checked="checked"<?php endif?> name="zone[statut]"></div>
					</div>
  				</div>
            	<div class="sf_admin_form_row sf_admin_text sf_admin_form_field_departements_list">
        			<div>
      					<label for="zone_departements_list">Liste des départements</label>
      					<div class="content">
      						<select id="zone_departements_list" multiple="multiple" size="10" name="zone[departements_list][]">
								<?php foreach($listeDepartement as $departement):?>
									<option value="<?php echo $departement->getIdDepartement()?>" <?php if(isset($zoneDepartements[$departement->getIdDepartement()])):?>selected="selected"<?php endif?>><?php echo $departement->getIdDepartement()." - ".$departement->getLibelle()?></option>
								<?php endforeach;?>
							</select>
						</div>
					</div>
  				</div>
  				<div class="sf_admin_form_row sf_admin_text sf_admin_form_field_poids_list">
        			<div>
      					<label for="zone_departements_list">Prix / Poids</label>
      					
	      					<div class="content">
	      						<table>
		      						<?php foreach ($listePoids as $_poids):?>
		      							<tr>
		      								<td><?php echo $_poids->getPoidsEnKg()?> kg</td>
		      								<td><input type="text" name="zone[poids_list][<?php echo $_poids->getIdPoids()?>]" value="<?php if(isset($zoneTarifs[$_poids->getIdPoids()])):?><?php echo $zoneTarifs[$_poids->getIdPoids()]?><?php endif?>"></td>
										</tr>
		      						<?php endforeach;?>
								</table>
							</div>
						
					</div>
  				</div>
      		</fieldset>
    		<ul class="sf_admin_actions">
    			<?php if($zone->getIdZone() == ""):?>
    				<li class="sf_admin_action_save"><input type="submit" name="btnSubmit" value="Ajouter"></li>
    			<?php else:?>
    				<li class="sf_admin_action_save"><input type="submit" name="btnSubmit" value="Mettre à jour"></li>
    			<?php endif?>
    		</ul>
  		</form>
  	</div>
</div>
