<?php

require_once dirname(__FILE__).'/../lib/mail_sujetGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/mail_sujetGeneratorHelper.class.php';

/**
 * mail_sujet actions.
 *
 * @package    sf_sandbox
 * @subpackage mail_sujet
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class mail_sujetActions extends autoMail_sujetActions
{
	public function executeMesMails(sfWebRequest $request)
	{
		// sorting
		if ($request->getParameter('sort') && $this->isValidSortColumn($request->getParameter('sort'))) {
			$this->setSort(array($request->getParameter('sort'), $request->getParameter('sort_type')));
		}

		// pager
		if ($request->getParameter('page')) {
			$this->setPage($request->getParameter('page'));
		}
		
		// set filters
		$this->setFilters(array(
			'id_user' => 1
		));

		$this->pager = $this->getPager();
		$this->sort = $this->getSort();
		
		$this->setTemplate('index');
	}
	
	public function executeUpdate(sfWebRequest $request)
	{
		$this->mail_sujet = $this->getRoute()->getObject();
		$this->form = $this->configuration->getForm($this->mail_sujet);
		
		$parameter = $request->getParameter($this->form->getName());
		
		$mail = Doctrine_Core::getTable("MailSujet")->find($parameter['id']);
		$mail->setIdUser($parameter['id_user']);
		$mail->setDateAssignation(date("Y-m-d H:i:s"));
		$mail->setStatut(MailSujet::STATUT_ASSIGNE);
		$mail->save();
		
		$this->form = $this->configuration->getForm($mail);

		$this->setTemplate('edit');
	}
	
	protected function processForm(sfWebRequest $request, sfForm $form)
	{
		$form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
		
		if ($form->isValid()) {
			$notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

			try {
				$mail_sujet = $form->save();
			} catch (Doctrine_Validator_Exception $e) {

				$errorStack = $form->getObject()->getErrorStack();

				$message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
				foreach ($errorStack as $field => $errors) {
				    $message .= "$field (" . implode(", ", $errors) . "), ";
				}
				$message = trim($message, ', ');

				$this->getUser()->setFlash('error', $message);
				return sfView::SUCCESS;
			}

			$this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $mail_sujet)));

			if ($request->hasParameter('_save_and_add'))
			{
				$this->getUser()->setFlash('notice', $notice.' You can add another one below.');

				$this->redirect('@mail_sujet_new');
			}
			else
			{
				$this->getUser()->setFlash('notice', $notice);

				$this->redirect(array('sf_route' => 'mail_sujet_edit', 'sf_subject' => $mail_sujet));
			}
		      }
		      else
		      {
			$this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
		      }
	}
	
	public function executeRepondre(sfWebRequest $request)
	{
		$sujet_id = $request->getParameter('id_sujet', null);
		
		$this->forward404If(is_null($sujet_id));
		
		// Récupérer sujet
		$sujet = Doctrine_Core::getTable("MailSujet")->find($sujet_id);
		$this->form = new MailReponseForm();
		
		if ($request->isMethod('post')) {
			if ($request->hasParameter('submit_close_resolved')) {
				$sujet->setStatut(MailSujet::STATUT_RESOLU);
				$sujet->save();
			} elseif ($request->hasParameter('submit_close_not_resolved')) {
				$sujet->setStatut(MailSujet::STATUT_NON_RESOLU);
				$sujet->save();
			} else {
				$this->form->bind($request->getParameter($this->form->getName()), $request->getFiles($this->form->getName()));
				$parameter = $request->getParameter($this->form->getName());

				if ($this->form->isValid()) {
					$mail_reponse = new MailReponse();
					$mail_reponse->setMessage($parameter['message']);
					$mail_reponse->setIdMailSujet($parameter['id_mail_sujet']);
					$mail_reponse->setDateReponse(date("Y-m-d H:i:s"));
					$mail_reponse->setIdUser($this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'));
					$mail_reponse->save();

					// Envoi mail
					$this->form = new MailReponseForm();
					$this->getUser()->setFlash('notice', "Votre message a bien été enregistré et transmis au client.");
				}

				// Récupérer sujet
				$sujet = Doctrine_Core::getTable("MailSujet")->find($sujet_id);
			}
		}
		
		$this->sujet = $sujet;
		
		// Formulaire réponse
		$this->form->setDefault('id_mail_sujet', $sujet_id);
	}
}

