<?php use_stylesheet('/sfDoctrinePlugin/css/global.css', 'first') ?>
<?php use_stylesheet('/sfDoctrinePlugin/css/default.css', 'first') ?>
<?php use_stylesheets_for_form($form) ?>
<?php use_javascripts_for_form($form) ?>
<div id="sf_admin_container">
	<h1><?php echo __('Mes mails', array(), 'messages') ?></h1>
	<div id="sf_admin_content">
		<div class="sf_admin_list">
			<?php if ($sf_user->hasFlash('notice')): ?>
				<div class="notice"><?php echo __($sf_user->getFlash('notice'), array(), 'sf_admin') ?></div>
			<?php endif; ?>

			<?php if ($sf_user->hasFlash('error')): ?>
				<div class="error"><?php echo __($sf_user->getFlash('error'), array(), 'sf_admin') ?></div>
			<?php endif; ?>

			<h3>Demande initiale</h3>
			<table style="width: 100%; max-width: 875px; min-width: 405px">
				<tbody>
					<tr class="sf_admin_row">
						<td class="sf_admin_text"><strong>Statut :</strong> <?php echo $sujet->getStatut(); ?></td>
						<td class="sf_admin_text"><strong>Code :</strong> <?php echo $sujet->getCode(); ?></td>
						<td class="sf_admin_text"><strong>Date de réception :</strong> <?php $date = new DateTime($sujet->getDateReception()); echo $date->format("d/m/Y H:i:s"); ?></td>
						<td class="sf_admin_text"><strong>Date d'assignation :</strong> <?php $date = new DateTime($sujet->getDateAssignation()); echo $date->format("d/m/Y H:i:s"); ?></td>
						<td class="sf_admin_text"><strong>Utilisateur assigné :</strong> <?php echo $sujet->getSfGuardUser()->getLastName(); ?> <?php echo $sujet->getSfGuardUser()->getFirstName(); ?></td>
					</tr>
					<tr class="sf_admin_row">
						<td class="sf_admin_text"><strong>Type :</strong> <?php echo $sujet->getType(); ?></td>
						<td class="sf_admin_text"><strong>Nom :</strong> <?php echo $sujet->getNom(); ?></td>
						<td class="sf_admin_text"><strong>Téléphone :</strong> <?php echo $sujet->getTelephone(); ?></td>
						<td class="sf_admin_text"><strong>Email :</strong> <?php echo $sujet->getEmail(); ?></td>
						<td class="sf_admin_text"><strong>Code postal :</strong> <?php echo $sujet->getCodePostal(); ?></td>
					</tr>
					<tr class="sf_admin_row">
						<th class="sf_admin_text" style="width: 30%"><strong>Message</strong></th>
						<td class="sf_admin_text" colspan="4"><?php echo nl2br($sujet->getMessage()); ?></td>
					</tr>
				</tbody>
			</table>
			<h3>Les échanges</h3>
			<?php if (count($sujet->getMailReponses()) > 0): ?>
				<table style="width: 100%; max-width: 875px; min-width: 405px">
					<tbody>
						<?php foreach ($sujet->getMailReponses() as $reponse): ?>
						
							<tr class="sf_admin_row odd">
								<th class="sf_admin_text" style="width: 30%">Réponse <strong><?php if (!is_null($reponse->getIdUser())): ?>de <?php echo $reponse->getSfGuardUser()->getLastName(); ?> <?php echo $reponse->getSfGuardUser()->getFirstName(); ?><?php else: ?>du client<?php endif; ?></strong> <br>le <strong><?php $date = new DateTime($reponse->getDateReponse()); echo $date->format("d/m/Y H:i:s"); ?></strong></th>
								<td class="sf_admin_text"><?php echo nl2br($reponse->getMessage()); ?></td>
							</tr>
						<?php endforeach; ?>
					</tbody>
				</table>
			<?php else: ?>
				<p>Aucun échange pour le moment...</p>
			<?php endif; ?>
			<h3>Répondre au client</h3>
			<form action="" method="post">
				<table id="job_form" style="width: 100%; max-width: 875px; min-width: 405px">
					<tbody>
						<tr>
							<th style="width: 30%;">Votre réponse</th>
							<td><?php echo $form['message']->render(array('rows' => 20, 'style' => 'width: 100%')) ?></td>
						</tr>
					</tbody>
					<tfoot>
						<tr>
							<td colspan="2">
								<input type="submit" value="Envoyer la réponse" />
							</td>
						</tr>
					</tfoot>
				</table>
				<?php echo $form->renderHiddenFields(); ?>
			</form>
			<h3>Autres actions</h3>
			<form action="" method="post">
				<input type="hidden" name="id_mail_sujet" value="<?php echo $sujet->getId(); ?>">
				<input type="submit" name="submit_close_resolved" value="Clôturer la demande avec succès" />
				<input type="submit" name="submit_close_not_resolved" value="Clôturer la demande sans solution" />
			</form>
		</div>
	</div>
</div>