<?php use_helper('I18N', 'Date') ?>
<?php include_partial('menu/assets') ?>

<div id="sf_admin_container">
  <h1><?php echo __('Edition du menu', array(), 'messages') ?></h1>

  <?php include_partial('menu/flashes') ?>

  <div id="sf_admin_header">
    <?php include_partial('menu/form_header', array('menu' => $menu, 'form' => $form, 'configuration' => $configuration)) ?>
  </div>

  <div id="sf_admin_content">
    <?php include_partial('menu/form', array('menu' => $menu, 'form' => $form, 'configuration' => $configuration, 'helper' => $helper)) ?>
  </div>

  <div id="sf_admin_footer">
    <?php include_partial('menu/form_footer', array('menu' => $menu, 'form' => $form, 'configuration' => $configuration)) ?>
  </div>
  
  <h1><?php echo __('Gestion des sous menu', null, 'messages') ?></h1>
  	<?php if ($sf_user->hasFlash('notice_sous_menu')): ?>
  		<div class="notice"><?php echo __($sf_user->getFlash('notice_sous_menu'), array(), 'sf_admin') ?></div>
	<?php endif; ?>
	<?php if ($sf_user->hasFlash('error_sous_menu')): ?>
  		<div class="error"><?php echo __($sf_user->getFlash('error_sous_menu'), array(), 'sf_admin') ?></div>
	<?php endif; ?>
	
	 <div id="sf_admin_content">
    	<?php if(sizeof($listeSousMenu) == 0):?>
  			<p>Aucun résultat.</p>
  		<?php else:?>
    		<div class="sf_admin_list">
      			<table cellspacing="0">
      				<thead>
        				<tr>
          					<th class="sf_admin_text sf_admin_list_th_id_sous_menu">
      							Id sous menu
      						</th>
							<th class="sf_admin_text sf_admin_list_th_libelle">
      							Libelle
      						</th>
							<th class="sf_admin_boolean sf_admin_list_th_url">
      							Url
      						</th>
      						<th class="sf_admin_boolean sf_admin_list_th_ordre">
      							Ordre
      						</th>
      						<th class="sf_admin_boolean sf_admin_list_th_actif">
      							Actif
      						</th>
          					<th id="sf_admin_list_th_actions">Actions</th>
        				</tr>
      				</thead>
      				<tfoot>
        				<tr>
          					<th colspan="6"><?php echo sizeof($listeSousMenu)?> résultat<?php if(sizeof($listeSousMenu) > 1):?>s<?php endif?></th>
        				</tr>
      				</tfoot>
      				<tbody>
      					<?php foreach($listeSousMenu as $_sous_menu):?>
	                  		<tr class="sf_admin_row odd">
	            				<td class="sf_admin_text sf_admin_list_td_id_sous_menu">
	  								<?php echo $_sous_menu->getIdSousMenu()?>
	  							</td>
								<td class="sf_admin_text sf_admin_list_td_libelle"><?php echo $_sous_menu->getLibelle()?></td>
								<td class="sf_admin_text sf_admin_list_td_url"><?php echo $_sous_menu->getUrl()?></td>
								<td class="sf_admin_text sf_admin_list_td_ordre"><?php echo $_sous_menu->getOrdre()?></td>
								<td class="sf_admin_boolean sf_admin_list_td_actif">
									<?php if($_sous_menu->getActif()):?>
										<?php echo image_tag("sfDoctrinePlugin/tick.png", array("title" => "Checked", "alt" => "Checked"))?>
	    							<?php endif?>
	    						</td>
	            				<td>
	  								<ul class="sf_admin_td_actions">
	    								<li class="sf_admin_action_edit"><a href="<?php echo url_for("@edit_sous_menu?id_menu=".$menu->getIdMenu()."&id_sous_menu=".$_sous_menu->getIdSousMenu()."&mode=update")?>">Modifier</a></li>
	    								<li class="sf_admin_action_delete"><a href="<?php echo url_for("@edit_sous_menu?id_menu=".$menu->getIdMenu()."&id_sous_menu=".$_sous_menu->getIdSousMenu()."&mode=delete")?>" onclick="return confirm('Etes vous sûr ?')">Supprimer</a></li>
	    							</ul>
								</td>
	          				</tr>
          				<?php endforeach;?>
              		</tbody>
    			</table>
  			</div>
		<?php endif?>
    		<ul class="sf_admin_actions">
      			<li class="sf_admin_action_new"><a href="<?php echo url_for("@menu_edit?id_menu=".$menu->getIdMenu())?>">Nouveau</a></li>
      		</ul>
	   	
	   	<form action="<?php echo url_for("@add_sous_menu?id_menu=".$menu->getIdMenu())?>" method="post">
	   		<input type="hidden" id="sous_menu_id_sous_menu" name="sous_menu[id_sous_menu]" value="<?php echo $sous_menu->getIdSousMenu()?>">
	   		<input type="hidden" id="sous_menu_id_menu" name="sous_menu[id_menu]" value="<?php echo $menu->getIdMenu()?>">
			<fieldset id="sf_fieldset_none">
				<div class="sf_admin_form_row sf_admin_text sf_admin_form_field_libelle">
        			<div>
      					<label for="sous_menu_libelle">Libelle</label>
      					<div class="content"><input type="text" id="sous_menu_libelle" name="sous_menu[libelle]" value="<?php echo $sous_menu->getLibelle()?>"></div>
					</div>
  				</div>
  				<div class="sf_admin_form_row sf_admin_text sf_admin_form_field_url">
        			<div>
      					<label for="sous_menu_url">Url</label>
      					<div class="content"><input type="text" id="sous_menu_url" name="sous_menu[url]" value="<?php echo $sous_menu->getUrl()?>"></div>
					</div>
  				</div>
  				<div class="sf_admin_form_row sf_admin_text sf_admin_form_field_ordre">
        			<div>
      					<label for="sous_menu_ordre">Ordre</label>
      					<div class="content"><input type="text" id="sous_menu_ordre" name="sous_menu[ordre]" value="<?php echo $sous_menu->getOrdre()?>"></div>
					</div>
  				</div>
            	<div class="sf_admin_form_row sf_admin_boolean sf_admin_form_field_actif">
 					<div>
      					<label for="sous_menu_actif">Actif</label>
      					<div class="content"><input type="checkbox" id="sous_menu_actif" <?php if($sous_menu->getActif()):?>checked="checked"<?php endif?> name="sous_menu[actif]"></div>
					</div>
  				</div>
      		</fieldset>
    		<ul class="sf_admin_actions">
    			<?php if($sous_menu->getIdSousMenu() == ""):?>
    				<li class="sf_admin_action_save"><input type="submit" name="btnSubmit" value="Ajouter"></li>
    			<?php else:?>
    				<li class="sf_admin_action_save"><input type="submit" name="btnSubmit" value="Mettre à jour"></li>
    			<?php endif?>
    		</ul>
  		</form>
  	</div>
</div>
