<?php

require_once dirname(__FILE__).'/../lib/nettoyeurhautepressionGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/nettoyeurhautepressionGeneratorHelper.class.php';

/**
 * nettoyeurhautepression actions.
 *
 * @package    sf_sandbox
 * @subpackage nettoyeurhautepression
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class nettoyeurhautepressionActions extends autoNettoyeurhautepressionActions
{
	public function executeEdit(sfWebRequest $request)
	{
		$this->nettoyeur_haute_pression = $this->getRoute()->getObject();

		$this->nettoyeur_haute_pression->setTemperature(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getTemperature()));
		$this->nettoyeur_haute_pression->setPressionService(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getPressionService()));
		$this->nettoyeur_haute_pression->setDebitLitreMin(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getDebitLitreMin()));
		$this->nettoyeur_haute_pression->setDebitLitreHeure(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getDebitLitreHeure()));
		$this->nettoyeur_haute_pression->setElectrique_220A(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getElectrique_220A()));
		$this->nettoyeur_haute_pression->setElectrique_220Kw(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getElectrique_220Kw()));
		$this->nettoyeur_haute_pression->setElectrique_220Hz(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getElectrique_220Hz()));
		$this->nettoyeur_haute_pression->setElectrique_380A(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getElectrique_380A()));
		$this->nettoyeur_haute_pression->setElectrique_380Kw(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getElectrique_380Kw()));
		$this->nettoyeur_haute_pression->setElectrique_380Hz(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getElectrique_380Hz()));
		$this->nettoyeur_haute_pression->setPoids(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getPoids()));
		$this->nettoyeur_haute_pression->setPrixVenteHT(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getPrixVenteHT()));
		$this->nettoyeur_haute_pression->setTauxRemiseFournisseur(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getTauxRemiseFournisseur()));
		$this->nettoyeur_haute_pression->setPrixVenteTHS(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getPrixVenteTHS()));
		$this->nettoyeur_haute_pression->setMargePourcentage(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getMargePourcentage()));
		$this->nettoyeur_haute_pression->setMargeEuro(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getMargeEuro()));
		$this->nettoyeur_haute_pression->setPrixTTC(Utils::doubleEnToFr($this->nettoyeur_haute_pression->getPrixTTC()));

		$this->form = $this->configuration->getForm($this->nettoyeur_haute_pression);
	}

	public function executeDelete(sfWebRequest $request)
	{
		$request->checkCSRFProtection();

		$this->dispatcher->notify(new sfEvent($this, 'admin.delete_object', array('object' => $this->getRoute()->getObject())));

		$filename = Utils::slugify(trim($this->getRoute()->getObject()->getMarque()->getLibelle())).'_'.Utils::slugify(trim($this->getRoute()->getObject()->getModele()));
		$filename = str_replace("-", "_", $filename);

		if ($this->getRoute()->getObject()->delete())
		{
			// Suppression des photos, vidéo et pdf
			for($i = 1; $i <= 5; $i++)
			{
				unlink(sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$filename.'_p'.$i.'.jpg');
				unlink(sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$filename.'_p'.$i.'.jpg');
			}
				
			unlink(sfConfig::get("nettoyeur_video_dir").DIRECTORY_SEPARATOR.$filename.'.flv');
				
			unlink(sfConfig::get("nettoyeur_pdf_doc_commercial_dir").DIRECTORY_SEPARATOR.$filename.'.pdf');
			unlink(sfConfig::get("nettoyeur_pdf_doc_technique_dir").DIRECTORY_SEPARATOR.$filename.'.pdf');
			unlink(sfConfig::get("nettoyeur_pdf_eclate_technique_dir").DIRECTORY_SEPARATOR.$filename.'.pdf');
				
			$this->getUser()->setFlash('notice', 'The item was deleted successfully.');
		}

		$this->redirect('@nettoyeur_haute_pression');
	}

	protected function processForm(sfWebRequest $request, sfForm $form)
	{
		$values = $request->getParameter($form->getName());
		$values["temperature"] = Utils::doubleFrToEn($values["temperature"]);
		$values["pression_service"] = Utils::doubleFrToEn($values["pression_service"]);
		$values["debit_litre_min"] = Utils::doubleFrToEn($values["debit_litre_heure"]) / 60;
		$values["debit_litre_heure"] = Utils::doubleFrToEn($values["debit_litre_heure"]);
		$values["electrique_220_a"] = Utils::doubleFrToEn($values["electrique_220_a"]);
		$values["electrique_220_kw"] = Utils::doubleFrToEn($values["electrique_220_kw"]);
		$values["electrique_220_hz"] = Utils::doubleFrToEn($values["electrique_220_hz"]);
		$values["electrique_380_a"] = Utils::doubleFrToEn($values["electrique_380_a"]);
		$values["electrique_380_kw"] = Utils::doubleFrToEn($values["electrique_380_kw"]);
		$values["electrique_380_hz"] = Utils::doubleFrToEn($values["electrique_380_hz"]);
		$values["poids"] = Utils::doubleFrToEn($values["poids"]);
		$values["prix_vente_ht"] = Utils::doubleFrToEn($values["prix_vente_ht"]);
		$values["taux_remise_fournisseur"] = Utils::doubleFrToEn($values["taux_remise_fournisseur"]);
		$values["prix_vente_ths"] = Utils::doubleFrToEn($values["prix_vente_ths"]);
		$values["marge_pourcentage"] = Utils::doubleFrToEn($values["marge_pourcentage"]);
		$values["marge_euro"] = Utils::doubleFrToEn($values["marge_euro"]);
		$values["prix_ttc"] = Utils::doubleFrToEn($values["prix_ttc"]);

		$form->bind($values, $request->getFiles($form->getName()));
		if ($form->isValid())
		{
			$notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';
				
			$modele = str_replace(" ", "_",trim($this->form->getValue('modele')));
			$marque = Doctrine::getTable("Marque")->find($this->form->getValue('id_marque'));
			$marque_libelle = trim($marque->getLibelle());

			// Mise à jour de du champs url_article et balise_title
			$values["url_article"] = sfConfig::get("app_url_site_web")."/".Utils::slugify($marque_libelle)."/".Utils::slugify($values["modele"]).".html";
			$values["balise_title"] = "Nettoyeur haute pression - ".$marque_libelle." ".$values["modele"];
				
			$filename_photo_1 = "";
			$filename_photo_2 = "";
			$filename_photo_3 = "";
			$filename_photo_4 = "";
			$filename_photo_5 = "";
			$filename_video_flv = "";
			$filename_doc_commercial = "";
			$filename_doc_technique = "";
			$filename_eclate_technique = "";
				
			$nettoyeur_haute_pression = new NettoyeurHautePression();
			if($this->form->getValue('id_nettoyeur') != "")
			{
				$nettoyeur_haute_pression = Doctrine::getTable("NettoyeurHautePression")->find($this->form->getValue('id_nettoyeur'));

				// Si changement de nom
				if($nettoyeur_haute_pression->getIdMarque() != $form->getValue('id_marque') || $nettoyeur_haute_pression->getModele() != $form->getValue('modele'))
				{
					$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($form->getValue('modele')));
					$filename = strtolower($filename);

					// renommer les fichiers
					if($nettoyeur_haute_pression->getPhoto_1() != "")
					{
						$extension = explode(".", $nettoyeur_haute_pression->getPhoto_1());
						rename(sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getPhoto_1(), sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
						$filename_photo_1 = $filename.".".$extension[sizeof($extension)-1];

						rename(sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getPhoto_1(), sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
					}
						
					if($nettoyeur_haute_pression->getPhoto_2() != "")
					{
						$extension = explode(".", $nettoyeur_haute_pression->getPhoto_2());
						rename(sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getPhoto_2(), sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
						$filename_photo_2 = $filename.".".$extension[sizeof($extension)-1];

						rename(sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getPhoto_2(), sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
					}
						
					if($nettoyeur_haute_pression->getPhoto_3() != "")
					{
						$extension = explode(".", $nettoyeur_haute_pression->getPhoto_3());
						rename(sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getPhoto_3(), sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
						$filename_photo_3 = $filename.".".$extension[sizeof($extension)-1];

						rename(sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getPhoto_3(), sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
					}
						
					if($nettoyeur_haute_pression->getPhoto_4() != "")
					{
						$extension = explode(".", $nettoyeur_haute_pression->getPhoto_4());
						rename(sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getPhoto_4(), sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
						$filename_photo_4 = $filename.".".$extension[sizeof($extension)-1];

						rename(sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getPhoto_4(), sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
					}
						
					if($nettoyeur_haute_pression->getPhoto_5() != "")
					{
						$extension = explode(".", $nettoyeur_haute_pression->getPhoto_5());
						rename(sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getPhoto_5(), sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
						$filename_photo_5 = $filename.".".$extension[sizeof($extension)-1];

						rename(sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getPhoto_5(), sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
					}
						
					if($nettoyeur_haute_pression->getDocCommercial() != "")
					{
						rename(sfConfig::get("nettoyeur_pdf_doc_commercial_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getDocCommercial(), sfConfig::get("nettoyeur_pdf_doc_commercial_dir").DIRECTORY_SEPARATOR.$filename.".pdf");
						$filename_doc_commercial = $filename.".pdf";
					}
						
					if($nettoyeur_haute_pression->getDocTechnique() != "")
					{
						rename(sfConfig::get("nettoyeur_pdf_doc_technique_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getDocTechnique(), sfConfig::get("nettoyeur_pdf_doc_technique_dir").DIRECTORY_SEPARATOR.$filename.".pdf");
						$filename_doc_technique = $filename.".pdf";
					}
						
					if($nettoyeur_haute_pression->getEclateTechnique() != "")
					{
						rename(sfConfig::get("nettoyeur_pdf_eclate_technique_dir").DIRECTORY_SEPARATOR.$nettoyeur_haute_pression->getEclateTechnique(), sfConfig::get("nettoyeur_pdf_eclate_technique_dir").DIRECTORY_SEPARATOR.$filename.".pdf");
						$filename_eclate_technique = $filename.".pdf";
					}
				}
			}

			if($values["id_nettoyeur"] != "")
			{
				// On récupère l'ancien objet pour avoir les noms des fichiers à supprimer
				$nhp_old = Doctrine::getTable("NettoyeurHautePression")->find($values["id_nettoyeur"]);

				// Suppression des photos si cases cochées
				if($form->getValue('photo_1_supprimer'))
				{
					unlink(sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_1());
					unlink(sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_1());
					$nettoyeur_haute_pression->setPhoto_1("");
				}

				if($form->getValue('photo_2_supprimer'))
				{
					unlink(sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_2());
					unlink(sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_2());
					$nettoyeur_haute_pression->setPhoto_2("");
				}

				if($form->getValue('photo_3_supprimer'))
				{
					unlink(sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_3());
					unlink(sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_3());
					$nettoyeur_haute_pression->setPhoto_3("");
				}

				if($form->getValue('photo_4_supprimer'))
				{
					unlink(sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_4());
					unlink(sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_4());
					$nettoyeur_haute_pression->setPhoto_4("");
				}

				if($form->getValue('photo_5_supprimer'))
				{
					unlink(sfConfig::get("nettoyeur_image_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_5());
					unlink(sfConfig::get("nettoyeur_miniature_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_5());
					$nettoyeur_haute_pression->setPhoto_5("");
				}

				if($form->getValue('video_flv_supprimer'))
				{
					unlink(sfConfig::get("nettoyeur_video_dir").DIRECTORY_SEPARATOR.$nhp_old->getVideoFlv());
					$nettoyeur_haute_pression->setVideoFlv("");
				}

				if($form->getValue('doc_commercial_supprimer'))
				{
					unlink(sfConfig::get("nettoyeur_pdf_doc_commercial_dir").DIRECTORY_SEPARATOR.$nhp_old->getDocCommercial());
					$nettoyeur_haute_pression->setDocCommercial("");
				}

				if($form->getValue('doc_technique_supprimer'))
				{
					unlink(sfConfig::get("nettoyeur_pdf_doc_technique_dir").DIRECTORY_SEPARATOR.$nhp_old->getDocTechnique());
					$nettoyeur_haute_pression->setDocTechnique("");
				}

				if($form->getValue('eclate_technique_supprimer'))
				{
					unlink(sfConfig::get("nettoyeur_pdf_eclate_technique_dir").DIRECTORY_SEPARATOR.$nhp_old->getEclateTechnique());
					$nettoyeur_haute_pression->setEclateTechnique("");
				}
			}
				
			// Enregistrement des images, vidéo et pdf
			if(!is_null($form->getValue('photo_1')))
			{
				$file = $form->getValue('photo_1');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele)).'_p1';
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('nettoyeur_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);

				// Création de la miniature
				$thumbnail = new sfThumbnail(300, 380, true, true, 100);
				$thumbnail->loadFile(sfConfig::get('nettoyeur_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$thumbnail->save(sfConfig::get('nettoyeur_miniature_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_photo_1 = $filename.$extension;
			}
				
			if(!is_null($form->getValue('photo_2')))
			{
				$file = $form->getValue('photo_2');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele)).'_p2';
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('nettoyeur_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);

				// Création de la miniature
				$thumbnail = new sfThumbnail(300, 380, true, true, 100);
				$thumbnail->loadFile(sfConfig::get('nettoyeur_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$thumbnail->save(sfConfig::get('nettoyeur_miniature_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_photo_2 = $filename.$extension;
			}
				
			if(!is_null($form->getValue('photo_3')))
			{
				$file = $form->getValue('photo_3');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele)).'_p3';
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('nettoyeur_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);

				// Création de la miniature
				$thumbnail = new sfThumbnail(300, 380, true, true, 100);
				$thumbnail->loadFile(sfConfig::get('nettoyeur_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$thumbnail->save(sfConfig::get('nettoyeur_miniature_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_photo_3 = $filename.$extension;
			}
				
			if(!is_null($form->getValue('photo_4')))
			{
				$file = $form->getValue('photo_4');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele)).'_p4';
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('nettoyeur_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);

				// Création de la miniature
				$thumbnail = new sfThumbnail(300, 380, true, true, 100);
				$thumbnail->loadFile(sfConfig::get('nettoyeur_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$thumbnail->save(sfConfig::get('nettoyeur_miniature_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_photo_4 = $filename.$extension;
			}
				
			if(!is_null($form->getValue('photo_5')))
			{
				$file = $form->getValue('photo_5');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele)).'_p5';
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('nettoyeur_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);

				// Création de la miniature
				$thumbnail = new sfThumbnail(300, 380, true, true, 100);
				$thumbnail->loadFile(sfConfig::get('nettoyeur_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$thumbnail->save(sfConfig::get('nettoyeur_miniature_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_photo_5 = $filename.$extension;
			}

			if(!is_null($form->getValue('video_flv')))
			{
				$file = $form->getValue('video_flv');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele));
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('nettoyeur_video_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_video_flv = $filename.$extension;
			}

			if(!is_null($form->getValue('doc_commercial')))
			{
				$file = $form->getValue('doc_commercial');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele));
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('nettoyeur_pdf_doc_commercial_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_doc_commercial = $filename.$extension;
			}

			if(!is_null($form->getValue('doc_technique')))
			{
				$file = $form->getValue('doc_technique');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele));
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('nettoyeur_pdf_doc_technique_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_doc_technique = $filename.$extension;
			}

			if(!is_null($form->getValue('eclate_technique')))
			{
				$file = $form->getValue('eclate_technique');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele));
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('nettoyeur_pdf_eclate_technique_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_eclate_technique = $filename.$extension;
			}

			try
			{
				$nettoyeur_haute_pression->setIdNettoyeur($form->getValue('id_nettoyeur'));
				$nettoyeur_haute_pression->setidMarque($form->getValue('id_marque'));
				$nettoyeur_haute_pression->setModele($form->getValue('modele'));
				$nettoyeur_haute_pression->setPosteFixe($form->getValue('poste_fixe'));
				$nettoyeur_haute_pression->setGroupeMoteurPompe($form->getValue('groupe_moteur_pompe'));
				$nettoyeur_haute_pression->setEauFroide($form->getValue('eau_froide'));
				$nettoyeur_haute_pression->setEauChaude($form->getValue('eau_chaude'));
				$nettoyeur_haute_pression->setVapeur($form->getValue('vapeur'));
				$nettoyeur_haute_pression->setTemperature($form->getValue('temperature'));
				$nettoyeur_haute_pression->setPressionService($form->getValue('pression_service'));
				$nettoyeur_haute_pression->setDebitLitreMin($form->getValue('debit_litre_min'));
				$nettoyeur_haute_pression->setDebitLitreHeure($form->getValue('debit_litre_heure'));
				$nettoyeur_haute_pression->setCalibre($form->getValue('calibre'));
				$nettoyeur_haute_pression->setElectrique_220($form->getValue('electrique_220'));
				$nettoyeur_haute_pression->setElectrique_220A($form->getValue('electrique_220_a'));
				$nettoyeur_haute_pression->setElectrique_220Kw($form->getValue('electrique_220_kw'));
				$nettoyeur_haute_pression->setElectrique_220Hz($form->getValue('electrique_220_hz'));
				$nettoyeur_haute_pression->setElectrique_380($form->getValue('electrique_380'));
				$nettoyeur_haute_pression->setElectrique_380A($form->getValue('electrique_380_a'));
				$nettoyeur_haute_pression->setElectrique_380Kw($form->getValue('electrique_380_kw'));
				$nettoyeur_haute_pression->setElectrique_380Hz($form->getValue('electrique_380_hz'));
				$nettoyeur_haute_pression->setMoteurThermique($form->getValue('moteur_thermique'));
				$nettoyeur_haute_pression->setMoteurThermiqueInfo($form->getValue('moteur_thermique_info'));
				$nettoyeur_haute_pression->setPoids($form->getValue('poids'));
				$nettoyeur_haute_pression->setDescription($form->getValue('description'));
				$nettoyeur_haute_pression->setReferenceThs($form->getValue('reference_ths'));
				$nettoyeur_haute_pression->setReferenceConstructeur($form->getValue('reference_constructeur'));
				$nettoyeur_haute_pression->setPrixVenteHt($form->getValue('prix_vente_ht'));
				$nettoyeur_haute_pression->setTauxRemiseFournisseur($form->getValue('taux_remise_fournisseur'));
				$nettoyeur_haute_pression->setPrixVenteThs($form->getValue('prix_vente_ths'));
				$nettoyeur_haute_pression->setMargePourcentage($form->getValue('marge_pourcentage'));
				$nettoyeur_haute_pression->setMargeEuro($form->getValue('marge_euro'));
				$nettoyeur_haute_pression->setPrixTtc($form->getValue('prix_ttc'));
				$nettoyeur_haute_pression->setStock($form->getValue('stock'));
				$nettoyeur_haute_pression->setFrancoDePort($form->getValue('franco_de_port'));
				$nettoyeur_haute_pression->setPromo($form->getValue('promo'));
				$nettoyeur_haute_pression->setUrlArticle($values["url_article"]);
				$nettoyeur_haute_pression->setBaliseTitle($values["balise_title"]);
				$nettoyeur_haute_pression->setBaliseMeta($form->getValue('balise_meta'));

				if(!is_null($form->getValue('photo_1')) || $filename_photo_1 != "")
				{
					$nettoyeur_haute_pression->setPhoto_1($filename_photo_1);
				}

				if(!is_null($form->getValue('photo_2')) || $filename_photo_2 != "")
				{
					$nettoyeur_haute_pression->setPhoto_2($filename_photo_2);
				}

				if(!is_null($form->getValue('photo_3')) || $filename_photo_3 != "")
				{
					$nettoyeur_haute_pression->setPhoto_3($filename_photo_3);
				}

				if(!is_null($form->getValue('photo_4')) || $filename_photo_4 != "")
				{
					$nettoyeur_haute_pression->setPhoto_4($filename_photo_4);
				}

				if(!is_null($form->getValue('photo_5')) || $filename_photo_5 != "")
				{
					$nettoyeur_haute_pression->setPhoto_5($filename_photo_5);
				}

				if(!is_null($form->getValue('video_flv')) || $filename_video_flv != "")
				{
					$nettoyeur_haute_pression->setVideoFlv($filename_video_flv);
				}

				if(!is_null($form->getValue('doc_commercial')) || $filename_doc_commercial != "")
				{
					$nettoyeur_haute_pression->setDocCommercial($filename_doc_commercial);
				}

				if(!is_null($form->getValue('doc_technique')) || $filename_doc_technique != "")
				{
					$nettoyeur_haute_pression->setDocTechnique($filename_doc_technique);
				}

				if(!is_null($form->getValue('eclate_technique')) || $filename_eclate_technique != "")
				{
					$nettoyeur_haute_pression->setEclateTechnique($filename_eclate_technique);
				}
				$nettoyeur_haute_pression->setDocTechniqueEspacePro($form->getValue('doc_technique_espace_pro'));
				$nettoyeur_haute_pression->setEclateTechniqueEspacePro($form->getValue('eclate_technique_espace_pro'));
				$nettoyeur_haute_pression->setActif($form->getValue('actif'));
				$nettoyeur_haute_pression->setDisponibleVente($form->getValue('disponible_vente'));
				$nettoyeur_haute_pression->setVisibleMoteurRecherche($form->getValue('visible_moteur_recherche'));
				$nettoyeur_haute_pression->setAfficherPrix($form->getValue('afficher_prix'));
				$nettoyeur_haute_pression->setPlusFabriquer($form->getValue('plus_fabriquer'));
				$nettoyeur_haute_pression->setNoIndex($form->getValue('no_index'));
				$nettoyeur_haute_pression->save();
			}
			catch (Doctrine_Validator_Exception $e)
			{

				$errorStack = $form->getObject()->getErrorStack();

				$message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
				foreach ($errorStack as $field => $errors)
				{
					$message .= "$field (" . implode(", ", $errors) . "), ";
				}
				$message = trim($message, ', ');

				$this->getUser()->setFlash('error', $message);
				return sfView::SUCCESS;
			}

			$this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $nettoyeur_haute_pression)));

			if ($request->hasParameter('_save_and_add'))
			{
				$this->getUser()->setFlash('notice', $notice.' You can add another one below.');

				$this->redirect('@nettoyeur_haute_pression_new');
			}
			else
			{
				$this->getUser()->setFlash('notice', $notice);

				$this->redirect(array('sf_route' => 'nettoyeur_haute_pression_edit', 'sf_subject' => $nettoyeur_haute_pression));
			}
		}
		else
		{
			$this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
		}
	}

	public function executeAssociation(sfWebRequest $request)
	{
		// Liste des marques
		$this->listeMarque = MarqueTable::getList();
		$this->listeFamille = array();
		$this->listeModeles = array();
		$this->recherche_marque = "";
		$this->recherche_modele = "";

		if($request->isMethod("post"))
		{
			try
			{
				if($request->hasParameter("btnEnregistrer"))
				{
					$listeIdAssociation = array();
					if($request->hasParameter("bloc"))
					{
						foreach($request->getPostParameter("bloc") as $id_famille => $donnees)
						{
							foreach ($donnees as $donnee)
							{
								if($donnee["ordre"] != "" || $donnee["texte"] != "" || $donnee["note"] != "" )
								{
									$bloc = new Association();
									if($donnee["id_association"] != "")
									{
										$bloc = Doctrine::getTable("Association")->find($donnee["id_association"]);
									}
									else
									{
										$bloc->setIdAssociation($donnee["id_association"]);
									}
										
									$bloc->setOrdre($donnee["ordre"]);
									$bloc->setTexte($donnee["texte"]);
									$bloc->setNote($donnee["note"]);
									$bloc->setIdFamille($id_famille);
									$bloc->setIdNettoyeur($request->getPostParameter("id_nettoyeur"));
									$bloc->save();
										
									$listeIdAssociation[] = $bloc->id_association;
										
									if(isset($donnee["ref_fournisseur"]))
									{
										$verif_doublon = array();
										$associationArticle = new Doctrine_Collection("AssociationArticle");
										foreach($donnee["ref_fournisseur"] as $key => $sous_block)
										{
											if($sous_block != "" && !isset($verif_doublon[$sous_block]))
											{
												$verif_doublon[$sous_block] = 1;
												$aArticle = new AssociationArticle();
												$aArticle->setIdAssociation($bloc->getIdAssociation());
												$aArticle->setReferenceThsSage($sous_block);
												$aArticle->setOrdre($donnee["ordre"][$key]);
												$associationArticle->add($aArticle);
											}
										}
										$bloc->setAssociationArticles($associationArticle);
										$bloc->save();
									}
								}
							}
						}
					}

					// Suppression des associations qui n'existent plus
					AssociationTable::deleteByIdNettoyeurExceptIdAssociations($request->getPostParameter("id_nettoyeur"), $listeIdAssociation);

					$this->recherche_marque = $request->getPostParameter("id_marque");
					$this->recherche_modele = $request->getPostParameter("id_modele");
						
					$this->getUser()->setFlash('notice', 'L\'objet a été mis à jour avec succès.', false);
				}
				else
				{
					$this->recherche_marque = $request->getPostParameter("recherche_marque");
					$this->recherche_modele = $request->getPostParameter("recherche_modele");
				}

				// On récupère la liste des modèles

				if($this->recherche_marque == "")
				{
					throw new Exception("Vous devez choisir une marque");
				}

				$this->listeModeles = NettoyeurHautePressionTable::getListByMarque($this->recherche_marque);

				if($this->recherche_modele == "")
				{
					throw new Exception("Vous devez choisir un modèle");
				}

				$this->nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($this->recherche_modele);
				$this->listeFamille = FamilleTable::recupererListeArticleFamille();

				// On récupère les blocs liés au NHP
				$this->associations = AssociationTable::getListByIdNettoyeur($this->nettoyeur->getIdNettoyeur());
			}
			catch(Exception $e)
			{
				$this->getUser()->setFlash('error', $e->getMessage(), false);
			}
		}
	}

	public function executeAssociationNomenclature(sfWebRequest $request)
	{
		// Liste des marques
		$this->listeMarque = MarqueTable::getList();
		$this->listeFamille = array();
		$this->listeModeles = array();
		$this->recherche_marque = "";
		$this->recherche_modele = "";
		
		$this->form_import = new NettoyeurNomenclatureImportForm();

		if($request->isMethod("post"))
		{
			try
			{
				if($request->hasParameter("btnEnregistrer"))
				{
					// Supprimer
					Doctrine::getTable("NettoyeurHautePressionNomenclature")->supprimerParNettoyeur($request->getPostParameter("id_nettoyeur"));

					// Ajouter
					$data = $request->getPostParameter("nettoyeur_nomenclature");
					foreach($data['liste'] as $id_nomenclature)
					{
						$objet = new NettoyeurHautePressionNomenclature();
						$objet->setIdNettoyeur($request->getPostParameter("id_nettoyeur"));
						$objet->setIdNomenclature($id_nomenclature);
						$objet->save();
					}

					$this->recherche_marque = $request->getPostParameter("id_marque");
					$this->recherche_modele = $request->getPostParameter("id_modele");
						
					$this->getUser()->setFlash('notice', 'L\'objet a été mis à jour avec succès.', false);
				}
				else
				{
					$this->recherche_marque = $request->getPostParameter("recherche_marque");
					$this->recherche_modele = $request->getPostParameter("recherche_modele");
				}

				// On récupère la liste des modèles

				if($this->recherche_marque == "")
				{
					throw new Exception("Vous devez choisir une marque");
				}

				$this->listeModeles = NettoyeurHautePressionTable::getListByMarque($this->recherche_marque);

				if($this->recherche_modele == "")
				{
					throw new Exception("Vous devez choisir un modèle");
				}

				$this->nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($this->recherche_modele);
				
				// On récupère la liste des Nomenclatures liés au nettoyeur
				$tmp_nomenclatures = Doctrine::getTable("NettoyeurHautePression")->findNomenclaturesLieesParNettoyeur($this->nettoyeur->getIdNettoyeur());
				$nomenclatures_selected = array();
				foreach($tmp_nomenclatures as $nomenclature)
				{
					$nomenclatures_selected[] = $nomenclature->getId();
				}
				
				// On récupère la liste des Nomenclatures non liés au NHP
				$tmp_nomenclatures = Doctrine::getTable("Nomenclature")->findAll();
				$nomenclatures = array();
				foreach($tmp_nomenclatures as $nomenclature)
				{
					$nomenclatures[$nomenclature->getId()] = $nomenclature->getReference().' - '.$nomenclature->getDesignation();
				}
				
				$this->form = new NettoyeurNomenclatureForm();
				$this->form->setChoices($nomenclatures);
				$this->form->setChoicesSelected($nomenclatures_selected);
				$this->form->configure();
			}
			catch(Exception $e)
			{
				$this->getUser()->setFlash('error', $e->getMessage(), false);
			}
		}
	}
	
	public function executeAssociationNomenclatureImport(sfWebRequest $request)
	{
		if($request->isMethod("POST"))
		{
			$form = new NettoyeurNomenclatureImportForm();
			$form->bind($request->getParameter('import'), $request->getFiles('import'));
			if($form->isValid())
			{
				$file = $form->getValue('file');

				$filename = 'uploaded_'.sha1($file->getOriginalName());
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('sf_upload_dir').'/'.$filename.$extension);

				//Récupère les données
				$fichier = sfConfig::get('sf_upload_dir').'/'.$filename.$extension;

				if (($handle = fopen($fichier, "r")) !== FALSE)
				{
					$cpt = 0;
					$cpt_duplicate_entry = 0;
					$cpt_error = 0;
					while (($data = fgetcsv($handle, 0, ";")) !== FALSE)
					{
						try
						{
							$objet = new NettoyeurHautePressionNomenclature();
							$objet->setIdNettoyeur($data[0]);
							$objet->setIdNomenclature($data[1]);
							$objet->setPosition($data[2]);
							$objet->setGras($data[3]);
							$objet->save();
							$cpt++;
						}
						catch (Exception $exception)
						{
							$cpt_error++;
						}
					}
					fclose($handle);
				}
				$this->getUser()->setFlash('notice', $cpt.' ligne(s) ont été importés, '.$cpt_error.' ligne(s) erronées');
			}
			else
			{
				$this->getUser()->setFlash('error', 'Erreur lors de l\'importation');
			}
		}
		unlink(sfConfig::get('sf_upload_dir').'/'.$filename.$extension);
		$this->redirect("@association_nomenclature_nettoyeur");
	}
	
	public function executeWatch(sfWebRequest $request)
	{
		// Liste des marques
		$this->listeMarque = MarqueTable::getList();
		$this->listeFamille = array();
		$this->listeModeles = array();
		$this->recherche_marque = "";
		$this->recherche_modele = "";

		if($request->isMethod("post"))
		{
			try
			{
				if($request->hasParameter("btnEnregistrer"))
				{
					$listeIdWebsite = array();
					if($request->hasParameter("bloc"))
					{
						foreach($request->getPostParameter("bloc") as $donnee)
						{
							if($donnee["name"] != "" && $donnee["url"] != "" && $donnee["before"] != ""  && $donnee["after"] != "")
							{
								$bloc = new PressureWasherWatchWebsite();
								if($donnee["id"] != "")
								{
									$bloc = Doctrine::getTable("PressureWasherWatchWebsite")->find($donnee["id"]);
								}
								else
								{
									$bloc->setId($donnee["id"]);
								}
								
								$bloc->setName($donnee["name"]);
								$bloc->setUrl($donnee["url"]);
								$bloc->setBeforePrice(str_replace("&amp;", "&", $donnee["before"]));
								$bloc->setAfterPrice(str_replace("&amp;", "&", $donnee["after"]));
								$bloc->setIdNettoyeur($request->getPostParameter("id_nettoyeur"));
								$bloc->save();
									
								$listeIdWebsite[] = $bloc->getId();
							}
						}
					}

					// Suppression des associations qui n'existent plus
					PressureWasherWatchWebsiteTable::deleteByIdNettoyeurExceptIdWebsite($request->getPostParameter("id_nettoyeur"), $listeIdWebsite);

					$this->recherche_marque = $request->getPostParameter("id_marque");
					$this->recherche_modele = $request->getPostParameter("id_modele");
						
					$this->getUser()->setFlash('notice', 'L\'objet a été mis à jour avec succès.', false);
				}
				else if($request->hasParameter("btnEnregistrerPrix"))
				{
					$objet = Doctrine::getTable("PressureWasherWatch")->find($request->getPostParameter("id_nettoyeur"));
					if(!$objet)
					{
						$objet = new PressureWasherWatch();
						$objet->setIdNettoyeur($request->getPostParameter("id_nettoyeur"));
					}
					$objet->setPrice($request->getPostParameter("prix_ths"));
					$objet->save();
					
					$this->recherche_marque = $request->getPostParameter("id_marque");
					$this->recherche_modele = $request->getPostParameter("id_modele");
				}
				else
				{
					$this->recherche_marque = $request->getPostParameter("recherche_marque");
					$this->recherche_modele = $request->getPostParameter("recherche_modele");
				}

				// On récupère la liste des modèles

				if($this->recherche_marque == "")
				{
					throw new Exception("Vous devez choisir une marque");
				}

				$this->listeModeles = NettoyeurHautePressionTable::getListByMarque($this->recherche_marque);

				if($this->recherche_modele == "")
				{
					throw new Exception("Vous devez choisir un modèle");
				}

				$this->nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($this->recherche_modele);
				$this->nettoyeur_surveillance = Doctrine::getTable("PressureWasherWatch")->find($this->nettoyeur->getIdNettoyeur());
				$this->sites_surveillance = Doctrine::getTable("PressureWasherWatchWebsite")->findByIdNettoyeur($this->nettoyeur->getIdNettoyeur());
				$pww = Doctrine::getTable("PressureWasherWatch")->find($this->nettoyeur->getIdNettoyeur());
				$this->price = 0;
				if($pww)
				{
					$this->price = $pww->getPrice();
				}
				// Pour chaque site on récupère l'historique
				$this->prix_historique = array();
				foreach ($this->sites_surveillance as $site) {
					$result = Doctrine::getTable("PressureWasherPriceHistory")->findByIdPwww($site->getId());
					if (sizeof($result) > 0) {
						$this->prix_historique[$site->getId()] = $result;
					}
				}
			}
			catch(Exception $e)
			{
				$this->getUser()->setFlash('error', $e->getMessage(), false);
			}
		}
	}

	public function executeRecupererModele(sfWebRequest $request)
	{
		$id_marque = $request->getPostParameter('id_marque');
		if ($request->isXmlHttpRequest())
		{
			return $this->renderComponent("nettoyeurhautepression", "chargementModele", array("id_marque" => $id_marque));
		}
		return sfView::NONE;
	}
	
	public function executeExportRecapitulatifAssociation(sfWebRequest $request)
	{
		$listeFamille = FamilleTable::recupererListeArticleFamille(1);
		$famille_libelle = array();
		foreach($listeFamille as $famille)
		{
			$famille_libelle[$famille->getIdFamille()] = $famille->getLibelle();
		}

		$liste = NettoyeurHautePressionTable::getListExportRecapitulatifAssociation();
		
		$resultat = array();
		foreach($liste as $element)
		{
			$resultat[$element["id_nettoyeur"]] = array();
			$resultat[$element["id_nettoyeur"]]["marque"] = $element["Marque"]["libelle"];
			$resultat[$element["id_nettoyeur"]]["modele"] = $element["modele"];
			foreach ($element["Associations"] as $sous_element)
			{
				foreach($sous_element["AssociationArticle"] as $association)
				{
					$resultat[$element["id_nettoyeur"]][$sous_element["id_famille"]][] = $association["reference_ths_sage"];
				}
			}
		}
		
		$cellules = array();
		$cellules[0] = "A";
		$cellules[1] = "B";
		$cellules[2] = "C";
		$cellules[3] = "D";
		$cellules[4] = "E";
		$cellules[5] = "F";
		$cellules[6] = "G";
		$cellules[7] = "H";
		$cellules[8] = "I";
		$cellules[9] = "J";
		$cellules[10] = "K";
		$cellules[11] = "L";
		$cellules[12] = "M";
		$cellules[13] = "N";
		$cellules[14] = "O";
		$cellules[15] = "P";
		$cellules[16] = "Q";
		$cellules[17] = "R";
		$cellules[18] = "S";
		$cellules[19] = "T";
		$cellules[20] = "U";
		$cellules[21] = "V";
		$cellules[22] = "W";
		$cellules[23] = "X";
		$cellules[24] = "Y";
		$cellules[25] = "Z";

		$objPHPExcel = new PHPExcel();
		$objPHPExcel->getProperties()->setCreator("Haute Pression")
							 ->setLastModifiedBy("Haute Pression")
							 ->setTitle("")
							 ->setSubject("")
							 ->setDescription("")
							 ->setKeywords("")
							 ->setCategory("");
		
		$objPHPExcel->setActiveSheetIndex(0);
		$objPHPExcel->getActiveSheet()->setCellValue('A1', "Marque");
		$objPHPExcel->getActiveSheet()->setCellValue('B1', "NHP");
		$i = 2;
		foreach($listeFamille as $famille)
		{
			$objPHPExcel->getActiveSheet()->setCellValue($cellules[$i].'1', $famille->getLibelle());
			$i++;
		}
		
		$i = 2;
		foreach ($resultat as $ligne)
		{
			$objPHPExcel->getActiveSheet()->setCellValue("A".$i, $ligne["marque"]);
			$objPHPExcel->getActiveSheet()->setCellValue("B".$i, $ligne["modele"]);
			$j = 2;
			foreach($listeFamille as $famille)
			{
				if(isset($ligne[$famille->getIdFamille()]))
				{
					$str = "";
					foreach ($ligne[$famille->getIdFamille()] as $sous_element)
					{
						if($str == "")
						{
							$objPHPExcel->getActiveSheet()->setCellValue($cellules[$j].$i, $sous_element);
						}
						$str .= $sous_element.", ";
					}
					$str = substr($str, 0, -2);
					
					$objValidation = $objPHPExcel->getActiveSheet()->getCell($cellules[$j].$i)->getDataValidation();
					$objValidation->setType( PHPExcel_Cell_DataValidation::TYPE_LIST );
					$objValidation->setErrorStyle( PHPExcel_Cell_DataValidation::STYLE_INFORMATION );
					$objValidation->setAllowBlank(false);
					$objValidation->setShowInputMessage(true);
					$objValidation->setShowErrorMessage(true);
					$objValidation->setShowDropDown(true);
					$objValidation->setFormula1('"'.$str.'"');
				}
				$j++;
			}
			$i++;
		}
		
		header('Content-Type: application/vnd.ms-excel');
		header('Content-Disposition: attachment;filename="export-recapitulatif-association.xls"');
		header('Cache-Control: max-age=0');

		$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
		$objWriter->save('php://output');

		return sfView::NONE;
	}
	
	public function executeRecapitulatifAssociation(sfWebRequest $request)
	{
		$stat = AssociationArticleTable::statistiqueReferenceFamille();
		$this->statistiques = array();
		
		foreach ($stat as $s)
		{
			$temp = array();
			$temp[0] = $s->getReferenceThsSage();
			$temp[1] = $s->getNombre();
			$id_famille = $s->getAssociation()->getFamille()->getIdFamille();
			$this->statistiques[$id_famille][] = $temp;
		}
		
		$this->liste = NettoyeurHautePressionTable::getListRecapitulatifAssociation();
		
		$this->resultat = array();
		foreach($this->liste as $element)
		{
			$this->resultat[$element["id_nettoyeur"]] = array();
			$this->resultat[$element["id_nettoyeur"]]["marque"] = $element["Marque"]["libelle"];
			$this->resultat[$element["id_nettoyeur"]]["modele"] = $element["modele"];
			foreach ($element["Associations"] as $sous_element)
			{
				foreach($sous_element["AssociationArticle"] as $association)
				{
					$temp = array();
					$temp["reference_ths_sage"] = $association["reference_ths_sage"];
					$temp["reference_ths"] = $association["Article"]["reference_ths"];
					$this->resultat[$element["id_nettoyeur"]][$sous_element["id_famille"]][] = $temp;
				}
			}
		}
		
		$this->listeFamille = FamilleTable::recupererListeArticleFamille(1);
	}
}