<?php

/**
 * devis actions.
 *
 * @package    sf_sandbox
 * @subpackage devis
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class devisActions extends sfActions
{
	/**
	 * Executes index action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeIndex(sfWebRequest $request)
	{
		$this->token = $request->getParameter("token");
		$this->id_commande = $request->getParameter("id_commande");
		$this->commande = Doctrine_Core::getTable("Commande")->findOneByIdCommandeAndDevisToken($this->id_commande, $this->token);

		if(!($this->commande instanceof Commande))
		{
			$this->getUser()->setFlash("erreur", 1);
			return sfView::ERROR;
		}
		elseif($this->commande->getIdStatut() != sfConfig::get("app_commande_statut_cree"))
		{
			$this->getUser()->setFlash("erreur", 2);
			return sfView::ERROR;
		}
		
		sfContext::getInstance()->getConfiguration()->loadHelpers("Url");
		$this->getUser()->setAttribute("signin_referer", url_for("@devis?id_commande=".$this->id_commande."&token=".$this->token));
		
		$filAriane = ' > <a href="'.url_for("@devis?id_commande=".$this->id_commande."&token=".$this->token).'">Notre devis</a>';
		$this->getUser()->setFlash("filAriane", $filAriane);
		$this->getResponse()->addMeta('title', "Notre devis");
		$this->getResponse()->addMeta('description', "Notre devis");

		$this->form = new PanierCoordonneesForm();

		$class = sfConfig::get('app_sf_guard_plugin_signin_form', 'sfGuardFormSignin');
		$this->userForm = new $class();

		if($this->getUser()->isAuthenticated())
		{
			// On récupère le client et on le préremplit
			$client = Doctrine_Core::getTable('Client')
			->createQuery('c')
			->where('c.id_user = ?', $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'))
			->execute();

			if(sizeof($client) > 0)
			{
				$client = $client[0];
				$this->form->setDefaults(array(
									'civilite' 				=> $client->getCivilite(),
									'nom' 					=> $client->getNom(),
									'prenom' 				=> $client->getPrenom(),
									'adresse' 				=> $client->getAdresse(),
									'adresse_complement' 				=> $client->getAdresseComplement(),
									'code_postal' 			=> $client->getCodePostal(),
									'ville' 				=> $client->getVille(),
									'pays' 					=> $client->getPays(),
									'telephone' 			=> $client->getTelephone(),
									'fax' 					=> $client->getFax(),
									'id' 					=> $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'),
									'email_address' 		=> $client->getEmail(),
									'email_confirmation'	=> $client->getEmail(),
									'livraison_civilite' 	=> $this->commande->getCivilite(),
									'livraison_nom' 		=> $this->commande->getNom(),
									'livraison_prenom' 		=> $this->commande->getPrenom(),
									'livraison_adresse' 	=> $this->commande->getAdresse(),
									'livraison_adresse_complement' 	=> $this->commande->getAdresseComplement(),
									'livraison_code_postal' => $this->commande->getCodePostal(),
									'livraison_ville' 		=> $this->commande->getVille(),
									'livraison_pays' 		=> $this->commande->getPays(),
									'livraison_telephone' 	=> $this->commande->getTelephone(),
									'livraison_fax' 		=> $this->commande->getFax(),
									'livraison_note'		=> $this->commande->getNoteLivraison(),
				));
			}
			else
			{
				// On récupère le sfGuard pour l'adresse email
				$sfUser = Doctrine_Core::getTable('sfGuardUser')->find($this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'));

				$this->form->setDefaults(array(
									'id' 					=> $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'),
									'nom' 					=> $sfUser->getLastName(),
									'prenom' 				=> $sfUser->getFirstName(),
									'email_address'			=> $sfUser->getUsername(),
									'email_confirmation'	=> $sfUser->getUsername(),
									'livraison_civilite' 	=> $this->commande->getCivilite(),
									'livraison_nom' 		=> $this->commande->getNom(),
									'livraison_prenom' 		=> $this->commande->getPrenom(),
									'livraison_adresse' 	=> $this->commande->getAdresse(),
									'livraison_adresse_complement' 	=> $this->commande->getAdresseComplement(),
									'livraison_code_postal' => $this->commande->getCodePostal(),
									'livraison_ville' 		=> $this->commande->getVille(),
									'livraison_pays' 		=> $this->commande->getPays(),
									'livraison_telephone' 	=> $this->commande->getTelephone(),
									'livraison_fax' 		=> $this->commande->getFax(),
									'livraison_note'		=> $this->commande->getNoteLivraison(),
				));
			}
		}

		if($request->isMethod("POST"))
		{
			$this->form->bind($request->getParameter($this->form->getName()), $request->getFiles($this->form->getName()));

			if($this->form->isValid())
			{
				$id_commande = $request->getParameter("id_commande");
				$commande = Doctrine_Core::getTable("Commande")->find($id_commande);

				$values = $this->form->getValues();

				if(sizeof($client) == 0)
				{
					if(!$this->getUser()->isAuthenticated())
					{
						// On créé un sfuser
						$sfUser = new sfGuardUser();
						$sfUser->setLastName($values['nom']);
						$sfUser->setFirstName($values['prenom']);
						$sfUser->setUsername($values['email_address']);
						$sfUser->setEmailAddress($values['email_address']);
						$sfUser->save();
						$this->getUser()->setAttribute('user_id', $sfUser->getId(), 'sfGuardSecurityUser');
						$this->getUser()->setAuthenticated(true);
					}

					$client = new Client();
				}
				$client->id_user = $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser');
				$client->civilite = $values['civilite'];
				$client->nom = $values['nom'];
				$client->prenom = $values['prenom'];
				$client->adresse = $values['adresse'];
				$client->adresse_complement = $values['adresse_complement'];
				$client->code_postal = $values['code_postal'];
				$client->ville = $values['ville'];
				$client->pays = $values['pays'];
				$client->telephone = $values['telephone'];
				$client->fax = $values['fax'];
				$client->email = $values['email_address'];

				if($values['livraison_civilite'] == "" || $values['livraison_nom'] == "" || $values['livraison_prenom'] == "" || $values['livraison_adresse'] == "" || $values['livraison_code_postal'] == "" || $values['livraison_ville'] == "" || $values['livraison_pays'] == "")
				{
					$commande->civilite = $values['civilite'];
					$commande->nom = $values['nom'];
					$commande->prenom = $values['prenom'];
					$commande->adresse = $values['adresse'];
					$commande->adresse_complement = $values['adresse_complement'];
					$commande->code_postal = $values['code_postal'];
					$commande->ville = $values['ville'];
					$commande->pays = $values['pays'];
					$commande->telephone = $values['telephone'];
					$commande->fax = $values['fax'];
				}
				else
				{
					$commande->civilite = $values['livraison_civilite'];
					$commande->nom = $values['livraison_nom'];
					$commande->prenom = $values['livraison_prenom'];
					$commande->adresse = $values['livraison_adresse'];
					$commande->adresse_complement = $values['livraison_adresse_complement'];
					$commande->code_postal = $values['livraison_code_postal'];
					$commande->ville = $values['livraison_ville'];
					$commande->pays = $values['livraison_pays'];
					$commande->telephone = $values['livraison_telephone'];
					$commande->fax = $values['livraison_fax'];
				}
				$commande->email = $values['email_address'];
				$commande->note_livraison = $values['livraison_note'];
				$commande->setClient($client);
				$commande->save();
				$this->getUser()->setAttribute("CommandeDevis", $commande);

				$this->redirect("@devis_paiement");
			}
		}
	}

	public function executeModePaiement(sfWebRequest $request)
	{
		$this->forward404If(!$this->getUser()->hasAttribute("CommandeDevis"));
		$this->commande = $this->getUser()->getAttribute("CommandeDevis");

		sfContext::getInstance()->getConfiguration()->loadHelpers("Url");
		$filAriane = ' > <a href="'.url_for("@devis_paiement").'">Paiement du devis</a>';
		$this->getUser()->setFlash("filAriane", $filAriane);
		$this->getResponse()->addMeta('title', "Paiement du devis");
		$this->getResponse()->addMeta('description', "Paiement du devis");
	}

	public function executeFinPaiement(sfWebRequest $request)
	{
		$this->forward404If(!$this->getUser()->hasAttribute("CommandeDevis"));
		$this->commande = $this->getUser()->getAttribute("CommandeDevis");
		if($request->isMethod("POST"))
		{
			sfContext::getInstance()->getConfiguration()->loadHelpers("Url");
			$filAriane = ' > <a href="'.url_for("@devis_fin").'">Finalisation du devis</a>';
			$this->getUser()->setFlash("filAriane", $filAriane);
			$this->getResponse()->addMeta('title', "Finalisation du devis");
			$this->getResponse()->addMeta('description', "Finalisation du devis");

			if($request->hasParameter('modePaiement'))
			{
				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT CHEQUE - DEBUT")));
				// Mise à jour de la commande
				$this->modePaiement = 0;
				$this->commande->setIdStatut(sfConfig::get("app_commande_statut_attente_paiement"));
				$this->commande->setMoyenPaiement(sfConfig::get("app_commande_moyen_paiement_cheque"));
				$this->commande->save();

				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT CHEQUE - ORDER ID ".$this->commande->getIdCommande())));
				// envoi email client
				$email_client = $this->commande->getEmail() ;

				if ($email_client != '')
				{
					$headers = "From: webmaster@haute-pression.com\n" .
					 "MIME-Version: 1.0\nContent-type: text/html; charset=UTF-8\n" .
					 "Reply-To: webmaster@haute-pression.com\n" ;
					
					
					if($this->commande->getIdUserSuiveur() != null)
					{
						$suiveur = Doctrine_Core::getTable('sfGuardUser')->find($this->commande->getIdUserSuiveur());
						$headers .= "Bcc: yenkong@lybliamay.fr;".$suiveur->getEmailAddress()."\n" ;
					}
					else
					{
						$headers .= "Bcc: yenkong@lybliamay.fr\n" ;
					}

					$emailSujet_client = "Votre commande www.haute-pression.com - Ref ".$this->commande->getIdCommande();
					$emailCorps_client = "Technique Haute pression & Sablage<br>\r\nLe Grand Colombier<br>\r\n24150 - BAYAC<br>\r\nFRANCE<br><br>\r\n\r\nTel: (+33 0)5 53 61 11 86<br>\r\n(+33 0)9 77 07 64 85<br>\r\nFax:(+33 0)5 53 58 39 98<br><br>\r\n\r\nEmail: contact@haute-pression.com<br><br>\r\n\r\n";
					$emailCorps_client .= "Cher Client,<br><br>\r\n\r\nVotre commande a bien été pris en compte. Nous vous prions de bien vouloir nous retourner le détail de la commande ainsi qu'un chèque d'un montant de ".Utils::doubleEnToFr($this->commande->getTotalTtc())." € à l'ordre de \"Technique Haute pression & Sablage\".<br>\r\nVotre référence de commande est : ".$this->commande->getIdCommande()."<br><br>\r\n\r\n" ;
					$emailCorps_client .= "<br><br>\r\n\r\nVous pouvez accéder à tout instant à votre suivi commande et à votre compte <b><a href='http://www.haute-pression.com/espace-client/mes-commandes.html'>sous ce lien</a></b>.<br><br>\r\n\r\n";
					$emailCorps_client .= "Nous procéderons au traitement de celle-ci dès la réception du chèque.<br><br>\r\n\r\nCordialement,<br><br>\r\n\r\nL'équipe THS<br>\r\n\r\n";
					$reponseMail = mail($email_client, $emailSujet_client, $emailCorps_client, $headers);
					if($reponseMail)
					{
						$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT CHEQUE - ENVOI MAIL CLIENT OK ".$email_client)));
					}
					else
					{
						$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT CHEQUE - ENVOI MAIL CLIENT KO ".$email_client)));
					}
				}
				$this->client = Doctrine_Core::getTable("Client")->find($this->commande->getIdClient());
				$this->envoieMailCommande($this->client, $this->commande);
				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT CHEQUE - FIN")));
			}
			elseif($request->hasParameter('PAIEMENT'))
			{
				$message="message=".$request->getParameter('DATA');
				$pathfile="pathfile=".sfConfig::get("app_paiement_chemin")."cgi-bin/citelis/param/pathfile";
				$path_bin = sfConfig::get("app_paiement_chemin")."cgi-bin/citelis/bin/response";
				$result=exec("$path_bin $pathfile $message");

				$tableau = explode ("!", $result);

				$code = $tableau[1];
				$error = $tableau[2];
				$merchant_id = $tableau[3];
				$merchant_country = $tableau[4];
				$amount = $tableau[5];
				$transaction_id = $tableau[6];
				$payment_means = $tableau[7];
				$transmission_date= $tableau[8];
				$payment_time = $tableau[9];
				$payment_date = $tableau[10];
				$response_code = $tableau[11];
				$payment_certificate = $tableau[12];
				$authorisation_id = $tableau[13];
				$currency_code = $tableau[14];
				$card_number = $tableau[15];
				$cvv_flag = $tableau[16];
				$cvv_response_code = $tableau[17];
				$bank_response_code = $tableau[18];
				$complementary_code = $tableau[19];
				$complementary_info = $tableau[20];
				$return_context = $tableau[21];
				$caddie = $tableau[22];
				$receipt_complement = $tableau[23];
				$merchant_language = $tableau[24];
				$language = $tableau[25];
				$customer_id = $tableau[26];
				$order_id = $tableau[27];
				$customer_email = $tableau[28];
				$customer_ip_address = $tableau[29];
				$capture_day = $tableau[30];
				$capture_mode = $tableau[31];
				$data = $tableau[32];

				if (($code == "") && ($error == ""))
				{
					$msg = "Erreur lors de l'initialisation du paiement";
					$this->modePaiement = 1;
				}
				elseif ($code != 0)
				{
					$msg = "API call error";
					$this->modePaiement = 1;
				}
				else
				{
					switch ($response_code)
					{
						case '0' :
						case '00' :
							$msg = "Autorisation acceptée";
							break;

						case '02' :
							$msg = "Demande d'autorisation par téléphone à la banque à cause d'un dépassement de plafond d'autorisation sur la carte";
							break;

						case  '03' :
							$msg = "Champ 'merchant_id' invalide";
							break;

						case  '05' :
							$msg = "Autorisation refusée";
							break;

						case  '12' :
							$msg = "Transaction invalide, vérifier les paramètres transférés dans la requête.";
							break;

						case  '17' :
							$msg = "Annulation de l'internaute";
							break;

						case  '30' :
							$msg = "Erreur de format";
							break;

						case  '34' :
							$msg = "Suspicion de fraude";
							break;

						case  '75' :
							$msg = "Nombre de tentatives de saisie du numéro de carte dépassé. ";
							break;

						case  '90' :
							$msg = "Service temporairement indisponible";
							break;

						default :
							$msg = "Valeur du champ 'response_code' inconnue : " . $response_code ;
							break;
					}

					$emailCorps = "";

					if ($response_code != '00' && $response_code != '0')
					{
						$emailSujet = "Un paiement a été refusé sur le site www.haute-pression.com";
						$emailCorps .= "Bonjour,\n<br>\n<br>Un paiement a été refusé sur le site http://www.haute-pression.com\n<br>";
						$emailCorps .= "Numéro de Commande : " . $this->commande->getIdCommande() . "\nMontant : " . ($amount / 100) . " EUR\n<br>\n<br>";
						$emailCorps .= "Code de retour : " . $response_code . "\n<br>Message : " . $msg . "\n<br>";
						$OrderStatus = "paiement refusé" ;
						
						$this->modePaiement = 2;
					}
					else
					{
						$emailSujet = "Un paiement a été effectué sur le site www.haute-pression.com";
						$emailCorps .= "Bonjour,\n<br>\n<br>Un paiement a été effectué sur le site http://www.haute-pression.com\n<br>";
						$emailCorps .= "Numéro de Commande : " . $this->commande->getIdCommande() . "\n<br>Montant : " . ($amount / 100) . " EUR\n<br>\n<br>";
						$OrderStatus = "payée" ;

						// envoi email client
						$email_client = utf8_decode(str_replace('"' , '&quot;' , $this->commande->getEmail())) ;

						if ($email_client != '')
						{
							$headers = "From: webmaster@haute-pression.com\n" .
							 "MIME-Version: 1.0\nContent-type: text/html; charset=UTF-8\n" .
							 "Reply-To: webmaster@haute-pression.com\n" ;
							$headers .= "Bcc: yenkong@lybliamay.fr\n" ;

							$emailSujet_client = "Votre commande www.haute-pression.com - Ref ".$this->commande->getIdCommande();
							$emailCorps_client = "Technique Haute pression & Sablage<br>\r\nLe Grand Colombier<br>\r\n24150 - BAYAC<br>\r\nFRANCE<br><br>\r\n\r\nTel: (+33 0)5 53 61 11 86<br>\r\n(+33 0)9 77 07 64 85<br>\r\nFax:(+33 0)5 53 58 39 98<br><br>\r\n\r\nEmail: contact@haute-pression.com<br><br>\r\n\r\n";
							$emailCorps_client .= "Cher Client,<br><br>\r\n\r\nVotre commande et votre règlement ont bien été pris en compte.<br>\r\nVotre référence de commande est : ".$this->commande->getIdCommande()."<br><br>\r\n\r\n" ;
							$emailCorps_client .= "<br><br>\r\n\r\nVous pouvez accéder à tout instant à votre suivi commande et à votre compte <b><a href='http://www.haute-pression.com/espace-client/mes-commandes.html'>sous ce lien</a></b>.<br><br>\r\n\r\n";
							$emailCorps_client .= "Nous procédons au traitement de celle-ci dans les plus brefs délais.<br><br>\r\n\r\nCordialement,<br><br>\r\n\r\nL'équipe THS<br>\r\n\r\n";
							mail($email_client, $emailSujet_client, $emailCorps_client, $headers);
						}
						$this->modePaiement = 3;
					}

					$emailTo = sfConfig::get("app_paiement_email");
					$headers = "From: webmaster@haute-pression.com\n" .
					"MIME-Version: 1.0\nContent-type: text/html; charset=UTF-8\n" .
					"Reply-To: webmaster@haute-pression.com\n" ;
					
					if($this->commande->getIdUserSuiveur() != null)
					{
						$suiveur = Doctrine_Core::getTable('sfGuardUser')->find($this->commande->getIdUserSuiveur());
						$headers .= "Bcc: yenkong@lybliamay.fr;".$suiveur->getEmailAddress()."\n" ;
					}
					else
					{
						$headers .= "Bcc: yenkong@lybliamay.fr\n" ;
					}
					
					mail($emailTo , $emailSujet , $emailCorps , $headers) ;
				}

				// Suppression de la commande en session
				$this->getUser()->getAttributeHolder()->remove('CommandeDevis');
			}
			else
			{
				$this->redirect("@devis_paiement");
			}
		}
	}

	public function executeFinPaiementAutomatic(sfWebRequest $request)
	{
		$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - DEBUT")));
		if($request->isMethod("POST"))
		{
			$message="message=".$request->getParameter('DATA');
			$pathfile="pathfile=".sfConfig::get("app_paiement_chemin")."cgi-bin/citelis/param/pathfile";
			$path_bin = sfConfig::get("app_paiement_chemin")."cgi-bin/citelis/bin/response";
			$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - REQUEST $path_bin $pathfile $message")));
			$result=exec("$path_bin $pathfile $message");
			$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - RESULT ".$result)));
			$tableau = explode ("!", $result);

			$code = $tableau[1];
			$error = $tableau[2];
			$merchant_id = $tableau[3];
			$merchant_country = $tableau[4];
			$amount = $tableau[5];
			$transaction_id = $tableau[6];
			$payment_means = $tableau[7];
			$transmission_date= $tableau[8];
			$payment_time = $tableau[9];
			$payment_date = $tableau[10];
			$response_code = $tableau[11];
			$payment_certificate = $tableau[12];
			$authorisation_id = $tableau[13];
			$currency_code = $tableau[14];
			$card_number = $tableau[15];
			$cvv_flag = $tableau[16];
			$cvv_response_code = $tableau[17];
			$bank_response_code = $tableau[18];
			$complementary_code = $tableau[19];
			$complementary_info = $tableau[20];
			$return_context = $tableau[21];
			$caddie = $tableau[22];
			$receipt_complement = $tableau[23];
			$merchant_language = $tableau[24];
			$language = $tableau[25];
			$customer_id = $tableau[26];
			$order_id = $tableau[27];
			$customer_email = $tableau[28];
			$customer_ip_address = $tableau[29];
			$capture_day = $tableau[30];
			$capture_mode = $tableau[31];
			$data = $tableau[32];

			$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - ORDER ID ".$order_id)));
				
			$commande = Doctrine_Core::getTable("Commande")->find($order_id);

			if (($code == "") && ($error == ""))
			{
				$msg = "Erreur lors de l'initialisation du paiement";
				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - ERROR ".$msg)));
			}
			elseif ($code != 0)
			{
				$msg = "API call error";
				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - ERROR ".$msg)));
			}
			else
			{
				switch ($response_code)
				{
					case '0' :
					case '00' :
						$msg = "Autorisation acceptée";
						break;

					case '02' :
						$msg = "Demande d'autorisation par téléphone à la banque à cause d'un dépassement de plafond d'autorisation sur la carte";
						break;

					case  '03' :
						$msg = "Champ 'merchant_id' invalide";
						break;

					case  '05' :
						$msg = "Autorisation refusée";
						break;

					case  '12' :
						$msg = "Transaction invalide, vérifier les paramètres transférés dans la requête.";
						break;

					case  '17' :
						$msg = "Annulation de l'internaute";
						break;

					case  '30' :
						$msg = "Erreur de format";
						break;

					case  '34' :
						$msg = "Suspicion de fraude";
						break;

					case  '75' :
						$msg = "Nombre de tentatives de saisie du numéro de carte dépassé. ";
						break;

					case  '90' :
						$msg = "Service temporairement indisponible";
						break;

					default :
						$msg = "Valeur du champ 'response_code' inconnue : " . $response_code ;
						break;
				}
				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - MESSAGE ".$msg)));

				$emailCorps = "";
				
				// Mise à jour de la commande
				$commande->setIdStatut(sfConfig::get("app_commande_statut_paye"));
				$commande->setMoyenPaiement(sfConfig::get("app_commande_moyen_paiement_ligne"));
				$commande->setNumeroTransaction($transaction_id);
				$commande->setNumeroCarte($card_number);
				$commande->setCertificatTransaction($payment_certificate);
				$commande->setDateTransaction(substr($payment_date, 0, 4)."-".substr($payment_date, 4, 2)."-".substr($payment_date, 6, 2)." ".substr($payment_time, 0, 2).":".substr($payment_time, 2, 2).":".substr($payment_time, 4, 2));
				$commande->save();

				if ($response_code != '00' && $response_code != '0')
				{
					$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - PAIEMENT REFUSE")));

					$emailSujet = "Un paiement a été refusé sur le site www.haute-pression.com";
					$emailCorps .= "Bonjour,\n<br>\n<br>Un paiement a été refusé sur le site http://www.haute-pression.com\n<br>";
					$emailCorps .= "Numéro de Commande : " . $commande->getIdCommande() . "\nMontant : " . ($amount / 100) . " EUR\n<br>\n<br>";
					$emailCorps .= "Code de retour : " . $response_code . "\n<br>Message : " . $msg . "\n<br>";
					$OrderStatus = "paiement refusé" ;

					// Mise à jour de la commande
					$commande->setIdStatut(sfConfig::get("app_commande_statut_echec_paiement"));
					$commande->save();
				}
				else
				{
					$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - PAIEMENT EFFECTUE")));

					$emailSujet = "Un paiement a été effectué sur le site www.haute-pression.com";
					$emailCorps .= "Bonjour,\n<br>\n<br>Un paiement a été effectué sur le site http://www.haute-pression.com\n<br>";
					$emailCorps .= "Numéro de Commande : " . $commande->getIdCommande() . "\n<br>Montant : " . ($amount / 100) . " EUR\n<br>\n<br>";
					$OrderStatus = "payée" ;

					// envoi email client
					$email_client = utf8_decode(str_replace('"' , '&quot;' , $commande->getEmail())) ;

					if ($email_client != '')
					{
						$headers = "From: webmaster@haute-pression.com\n" .
						 "MIME-Version: 1.0\nContent-type: text/html; charset=UTF-8\n" .
						 "Reply-To: webmaster@haute-pression.com\n" ;
						$headers .= "Bcc: yenkong@lybliamay.fr\n" ;

						$emailSujet_client = "Votre commande www.haute-pression.com - Ref ".$commande->getIdCommande();
						$emailCorps_client = "Technique Haute pression & Sablage<br>\r\nLe Grand Colombier<br>\r\n24150 - BAYAC<br>\r\nFRANCE<br><br>\r\n\r\nTel: (+33 0)5 53 61 11 86<br>\r\n(+33 0)9 77 07 64 85<br>\r\nFax:(+33 0)5 53 58 39 98<br><br>\r\n\r\nEmail: contact@haute-pression.com<br><br>\r\n\r\n";
						$emailCorps_client .= "Cher Client,<br><br>\r\n\r\nVotre commande et votre règlement ont bien été pris en compte.<br>\r\nVotre référence de commande est : ".$commande->getIdCommande()."<br><br>\r\n\r\n" ;
						$emailCorps_client .= "<br><br>\r\n\r\nVous pouvez accéder à tout instant à votre suivi commande et à votre compte <b><a href='http://www.haute-pression.com/espace-client/mes-commandes.html'>sous ce lien</a></b>.<br><br>\r\n\r\n";
						$emailCorps_client .= "Nous procédons au traitement de celle-ci dans les plus brefs délais.<br><br>\r\n\r\nCordialement,<br><br>\r\n\r\nL'équipe THS<br>\r\n\r\n";
						mail($email_client, $emailSujet_client, $emailCorps_client, $headers);

						$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - ENVOI MAIL CLIENT")));
					}
				}

				$emailTo = sfConfig::get("app_paiement_email");
				$headers = "From: webmaster@haute-pression.com\n" .
				"MIME-Version: 1.0\nContent-type: text/html; charset=UTF-8\n" .
				"Reply-To: webmaster@haute-pression.com\n" ;
				$headers .= "Bcc: yenkong@lybliamay.fr\n" ;
				mail($emailTo , $emailSujet , $emailCorps , $headers) ;
				
				$client = Doctrine_Core::getTable("Client")->find($commande->getIdClient());
				$this->envoieMailCommande($client, $commande);
				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - ENVOI MAIL ADMIN")));
			}
		}
		else
		{
			$this->redirect("@devis_paiement");
		}
		$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - FIN")));
	}
	
	private function envoieMailCommande($client, $commande)
	{
		$modePaiement = sfConfig::get('app_commande_moyen_paiement_libelle');
		sfContext::getInstance()->getConfiguration()->loadHelpers("Number");
		
		$body = "<table style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:600px;'>
					<tr>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Id client:</strong> ".strtoupper($client->getNom().$client->getPrenom())."<br /><strong>email:</strong> ".$client->getEmail()."</td>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Date de création:</strong> ".$commande->getDateCreationFr()."<br /><strong>N° de commande:</strong> ".$commande->getIdCommande()."</td>
					</tr>
					<tr>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;text-align:center'>FACTURATION</td>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;text-align:center'>LIVRAISON</td>
					</tr>
					<tr>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'>
							<strong>Civilité:</strong> ".strtoupper($client->getCivilite())."<br />
							<strong>Nom:</strong> ".strtoupper($client->getNom())."<br />
							<strong>Prénom:</strong> ".strtoupper($client->getPrenom())."<br />
							<strong>Adresse:</strong> ".strtoupper($client->getAdresse())."<br />
							<strong>Complément d'adresse:</strong> ".strtoupper($client->getAdresseComplement())."<br />
							<strong>Code postal:</strong> ".strtoupper($client->getCodePostal())."<br />
							<strong>Ville:</strong> ".strtoupper($client->getVille())."<br />
							<strong>Tel:</strong> ".$client->getTelephone()."<br />
							<strong>Fax:</strong> ".$client->getFax()."
						</td>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'>
							<strong>Civilité:</strong> ".strtoupper($commande->getCivilite())."<br />
							<strong>Nom:</strong> ".strtoupper($commande->getNom())."<br />
							<strong>Prénom:</strong> ".strtoupper($commande->getPrenom())."<br />
							<strong>Adresse:</strong> ".strtoupper($commande->getAdresse())."<br />
							<strong>Complément d'adresse:</strong> ".strtoupper($commande->getAdresseComplement())."<br />
							<strong>Code postal:</strong> ".strtoupper($commande->getCodePostal())."<br />
							<strong>Ville:</strong> ".strtoupper($commande->getVille())."<br />
							<strong>Tel:</strong> ".$commande->getTelephone()."<br />
							<strong>Fax:</strong> ".$commande->getFax()."
						</td>
					</tr>
					<tr>
						<td colspan='2' style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Note sur livraison:</strong> ".$commande->getNoteLivraison()."</td>
					</tr>
					<tr>
						<td colspan='2' style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Montant HT:</strong> ".format_currency($commande->getTotalHt())."€ - <strong>Montant TTC:</strong> ".format_currency($commande->getTotalTtc())."€</td>
					</tr>";

		$statutCommande = sfConfig::get('app_commande_statut_libelle');
		$body .= "	<tr>
						<td colspan='2' style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Port HT:</strong> ".format_currency($commande->getFraisPortHt())."€</td>
					</tr>
					<tr>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Mode de paiement:</strong> ".$modePaiement[$commande->getMoyenPaiement()]."</td>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Statut de la commande:</strong> ".$statutCommande[$commande->getIdStatut()]."</td>
					</tr>
				</table>";
		$body .= "<br /><br /><br /><br /><br /><br />".$body;

		$header = "Un paiement a été effectué sur le site <a href='http://www.haute-pression.com' target='_blank'>http://www.haute-pression.com</a><br /><br/>";
		$header .= "Mode de paiement : ".$modePaiement[$commande->getMoyenPaiement()]."<br />";
		$header .= "Prix Total TTC : ".format_currency($commande->getTotalTtc())."€<br />";
		$header .= "Numéro de la commande : ".$commande->getIdCommande()."<br />";
		if($commande->getMoyenPaiement() == 1)
		{
			$header .= "Date de la transaction : ".Utils::dateEnToFr($commande->getDateTransaction())."<br />";
			$header .= "Référence de la transaction : ".$commande->getNumeroTransaction()."<br />";
			$header .= "Numéro de la carte : ".$commande->getNumeroCarte()."<br />";
			$header .= "Certificat de la transaction : ".$commande->getCertificatTransaction()."<br />";
		}
		
		$id_suiveur = $commande->getIdUserSuiveur();
		if(!empty($id_suiveur))
		{
			// on récupère le commercial 
			$commercial = Doctrine_Core::getTable("sfGuardUser")->find($id_suiveur);
			$header .= "Commercial : ".$commercial->getUsername()."<br />";
		}
		
		$body = $header."<br /><br />".$body;
		
		$message = Swift_Message::newInstance()
		->setSubject('Nouvelle commande')
		->setFrom(array(sfConfig::get("app_paiement_email") => 'Commande Haute pression'));
		if(!empty($id_suiveur))
		{
			$message->setTo(array(sfConfig::get("app_paiement_email")=>'Commande Haute pression', sfConfig::get("app_paiement_email_1")=>'Commande Haute pression', sfConfig::get("app_paiement_email_2")=>'Commande Haute pression', $commercial->getUsername()=>$commercial->getLastName()." ".$commercial->getFirstName()));
		}
		else
		{
			$message->setTo(array(sfConfig::get("app_paiement_email")=>'Commande Haute pression', sfConfig::get("app_paiement_email_1")=>'Commande Haute pression', sfConfig::get("app_paiement_email_2")=>'Commande Haute pression'));
		}
		$message->setBcc(array('yenkong@lybliamay.fr'=>'Commande Haute pression'))
		->setBody($body, 'text/html');
			
		$this->getMailer()->send($message);

		$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT AUTOMATIC - ENVOI MAIL COMMANDE")));
	}
}
