<?php

/**
 * nettoyeur actions.
 *
 * @package    sf_sandbox
 * @subpackage nettoyeur
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class nettoyeurActions extends sfActions
{
	/**
	 * Executes index action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeIndex(sfWebRequest $request)
	{
		if(strpos($_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'], '/nettoyeur-haute-pression/') != false && $request->hasParameter("marque") && $request->hasParameter("modele")) {
			$this->redirect($this->generateUrl("url_nettoyeur", array("marque"=>$request->getParameter("marque"), "modele"=>$request->getParameter("modele"))), '301');
			exit;
		}
		
		if($request->hasParameter("id_nettoyeur"))
		{
			$this->nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($request->getParameter("id_nettoyeur"));
		}
		else if($request->hasParameter("marque") && $request->hasParameter("modele"))
		{
			$this->nettoyeur = NettoyeurHautePressionTable::getNettoyeurByMarqueModeleFromUrl($request->getParameter("marque"), $request->getParameter("modele"));
		}

		$this->forward404If(!($this->nettoyeur instanceof NettoyeurHautePression));

		$filAriane = ' > <a href="'.$this->nettoyeur->getUrlArticle().'">'.$this->nettoyeur->getBaliseTitle().'</a>';
		$this->getUser()->setFlash("filAriane", $filAriane);
		$this->getResponse()->addMeta('title', $this->nettoyeur->getBaliseTitle());
		$this->getResponse()->addMeta('description', $this->nettoyeur->getBaliseMeta());
		if($this->nettoyeur->getNoIndex())
		{
			$this->getResponse()->addMeta('robots', 'NOINDEX, NOFOLLOW');
		}
		else
		{
			$this->getResponse()->addMeta('robots', 'INDEX, FOLLOW');
		}
		
		$this->associations = AssociationTable::getListByIdNettoyeurForFrontend($this->nettoyeur->getIdNettoyeur());

		// Panier
		$nombre_articles = 0;
		if($this->getUser()->hasAttribute('commande_articles'))
		{
			$panier = $this->getUser()->getAttribute('commande_articles');
			$nombre_articles = sizeof($panier['article']) + sizeof($panier['nettoyeur']);
			
			$annule_minimum_commande = false;
			
			if(sizeof($panier['article']) > 0)
			{
				foreach ($panier['article'] as $article) 
				{
					$_article = Doctrine::getTable("Article")->find($article->getIdArticle());
					if($_article->getMinimumCommande())
					{
						$annule_minimum_commande = true;
						break;
					}
				}
			}
			
			$commande = $this->getUser()->getAttribute("commande");
			if($commande->getMailCommande() == 0 && !$annule_minimum_commande)
			{
				$this->minimumCommande = ConfigTable::getMinimumCommande();
			}
			else
			{
				$this->minimumCommande = 0;
			}
			$this->getUser()->setFlash("minimumCommande", $this->minimumCommande);
		}
		if($nombre_articles > 0)
		{
			$panier = $this->getUser()->getAttribute('commande_articles');

			// DonnÃ©es concernant frais de ports
			$francoDePort = 0;
			$horsGabarit = 0;
			$totalPoids = 0;

			$totalProduitsHTTemp = 0;
			$totalProduitsHT = 0;
			$totalProduitsTTC = 0;
			$totalPortHT = 0;
			$totalHT = 0;
			$totalTVA = 0;
			$totalTTC = 0;
			$tva = Doctrine_Core::getTable("TauxTVA")->find(sfConfig::get('app_tva_196'));
				
			$nombre_total_articles = 0;

			foreach ($panier['article'] as $key => $commandeArticle)
			{
				$article = Doctrine::getTable("Article")->find($key);
				$totalProduitsHTTemp += $article->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalProduitsHT += $article->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalPoids += Utils::doubleFrToEn($article->getPoids()) * $commandeArticle->getQuantite();
				$totalTVA += $article->getPrixVenteThs() * $commandeArticle->getQuantite() * $tva->getTaux() / 100;
					
				if($article->getHorsGabarit())
				{
					$horsGabarit = 1;
				}
					
				$nombre_total_articles += $commandeArticle->getQuantite();
			}

			$totalProduitsTTC += $totalProduitsHTTemp * (1 + $tva->getTaux() / 100);
			$totalProduitsHTTemp = 0;

			foreach ($panier['nettoyeur'] as $key => $commandeArticle)
			{
				$nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($key);
				$totalProduitsHTTemp += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalProduitsHT += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalPoids += Utils::doubleFrToEn($nettoyeur->getPoids()) * $commandeArticle->getQuantite();
				$totalTVA += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite() * $tva->getTaux() / 100;
					
				if($nettoyeur->getFrancoDePort())
				{
					$francoDePort = 1;
				}
				$nombre_total_articles += $commandeArticle->getQuantite();
			}
			$totalProduitsTTC += $totalProduitsHTTemp * (1 + $tva->getTaux() / 100);

			if(!$francoDePort &&!$horsGabarit && $totalPoids <= 10)
			{
				$tarif = ZoneTarifTable::calculFraisDePort($totalPoids * 1000, 0, '69');
					
				if(sizeof($tarif) > 0)
				{
					$tarif = $tarif[0];
				}
				$totalPortHT = $tarif->getZone()->getTransporteur()->getForfaitEmballage() + $tarif->getTarif();
				$totalTVA += $totalPortHT * $tva->getTaux() / 100;
			}

			$totalPortTTC = Utils::prixAvecTVA($totalPortHT, $tva->getTaux());

			// Arrondi
			$totalProduitsTTC = round($totalProduitsTTC, 2);
			$totalPortTTC = round($totalPortTTC, 2);
			$totalTVA = round($totalTVA, 2);

			$totalHT = $totalProduitsHT + $totalPortHT;
			$totalTTC = $totalProduitsTTC + $totalPortTTC;
			
			$this->nombre_articles = $nombre_articles;
			$this->getUser()->setFlash("nombre_articles", $this->nombre_articles);
			$this->nombre_total_articles = $nombre_total_articles;
			$this->getUser()->setFlash("nombre_total_articles", $this->nombre_total_articles);
			$this->totalProduitsHT = $totalProduitsHT;
			$this->getUser()->setFlash("totalProduitsHT", $this->totalProduitsHT);
			$this->francoDePort = $francoDePort;
			$this->getUser()->setFlash("francoDePort", $this->francoDePort);
			$this->horsGabarit = $horsGabarit;
			$this->getUser()->setFlash("horsGabarit", $this->horsGabarit);
			$this->totalPoids = $totalPoids;
			$this->getUser()->setFlash("totalPoids", $this->totalPoids);
			$this->totalPortHT = $totalPortHT;
			$this->getUser()->setFlash("totalPortHT", $this->totalPortHT);
			$this->totalHT = $totalHT;
			$this->getUser()->setFlash("totalHT", $this->totalHT);
			$this->totalTVA = $totalTVA;
			$this->getUser()->setFlash("totalTVA", $this->totalTVA);
			$this->totalTTC = $totalTTC;
			$this->getUser()->setFlash("totalTTC", $this->totalTTC);
		}
		
		// On récupère les nomenclatures
		$this->nomenclatures = NettoyeurHautePressionNomenclatureTable::recupererNomenclatureParNettoyeur($this->nettoyeur->getIdNettoyeur());
	}
	
	public function executeWatchPrice(sfWebRequest $request)
	{
		// Restriction par adresse ip
		header('Content-type: text/html; charset=UTF-8');
		
		function get_web_page( $url, $url_referer ) {
		    $options = array(
		        CURLOPT_RETURNTRANSFER => true,
		        CURLOPT_HEADER         => false,
		        CURLOPT_FOLLOWLOCATION => false,
		        CURLOPT_USERAGENT      => "spider",
		        CURLOPT_CONNECTTIMEOUT => 30,
		        CURLOPT_TIMEOUT        => 30,
		        CURLOPT_REFERER 	   => $url_referer,
				CURLOPT_ENCODING	   => 'UTF-8',
	
		    );
		
		    $ch      = curl_init( $url );
		    curl_setopt_array( $ch, $options );
		    $content = curl_exec( $ch );
		    $err     = curl_errno( $ch );
		    $errmsg  = curl_error( $ch );
		    $header  = curl_getinfo( $ch );
		    curl_close( $ch );
		
		    $header['errno']   = $err;
		    $header['errmsg']  = $errmsg;
		    $header['content'] = $content;
		    return $header;
		}
		
		$fp = fopen(sfConfig::get('sf_log_dir')."/".date("YmdHis").".log", "w");
		fwrite($fp, "Date début : ".date("d/m/Y H:i:s")."\n");
		
		// on récupère tous les sites
		$web_sites = Doctrine::getTable("PressureWasherWatchWebsite")->findAll();
		
		fwrite($fp, "PressureWasherWatchWebsite findAll : ".sizeof($web_sites)."\n");
		
		foreach($web_sites as $web_site) {
			
			fwrite($fp, "Check : ".$web_site->getUrl()."\n");
			
			$parse = parse_url($web_site->getUrl());
			$url_parse = $parse['scheme']."://".$parse['host'];
			$resultat = get_web_page($web_site->getUrl(), $url_parse);
			
			fwrite($fp, "Get : ".$web_site->getUrl()."\n");
			
			$resultat['content'] = str_replace("\t", "", $resultat['content']);
			$resultat['content'] = str_replace("\n", "", $resultat['content']);
			$resultat['content'] = str_replace("\r", "", $resultat['content']);
			$resultat['content'] = str_replace(" ", "", $resultat['content']);
			
			$pattern = "#".$web_site->getBeforePrice()."(.*)".$web_site->getAfterPrice()."#";
			
			fwrite($fp, "Pattern : ".$pattern."\n");
			$matches = array();
			preg_match_all($pattern, $resultat['content'], $matches);
			
			fwrite($fp, "preg_match_all : ".sizeof($matches[1])."\n");
			if(sizeof($matches[1]) > 0) {
				foreach($matches[1] as $match) {
					fwrite($fp, "save preg_match_all 0 : ".$match."\n");
					$price = str_replace(",", ".", $match);
					$price = strip_tags($price);
					if(is_numeric($price)) {
						$pwph = new PressureWasherPriceHistory();
						$pwph->setDateTime(date("Y-m-d H:i:s"));
						$pwph->setSource($resultat['content']);
						$pwph->setPrice($price);
						$pwph->setIdPwww($web_site->getId());
						$pwph->save();
						
						fwrite($fp, "save : ".$pwph->getId()."\n");
					}
				}
			}
		
			fwrite($fp, "sleep\n");
			sleep(1);
		}
		
		fwrite($fp, "Date fin : ".date("d/m/Y H:i:s")."\n");
		
		return sfView::NONE;
	}
}