<?php 
	use_helper('I18N', 'Number');
	$commande =  $sf_user->getAttribute("commande");
	$client = $commande->getClient();
?>
<div id="panier">
	<div id="panierEntete">
		<p>Mon panier</p>
		<ul>
			<li><?php echo link_to("1 - Calcul du panier", "@panier")?></li>
			<li><?php echo link_to("2 - Coordonnées", "@panier_coordonnees")?></li>
			<li class="selected">3 - Récapitulatif</li>
			<li>4 - Paiement</li>
		</ul>
	</div>
	<div style="clear: both;"></div>
	<table id="paiementPanier">
		<tr>
			<td>
				<p class="entete">Adresse de facturation</p>
				<p>
					<?php echo $client->getCivilite()?> <?php echo $client->getNom()?> <?php echo $client->getPrenom()?><br />
					<?php echo $client->getAdresse()?><br />
					<?php if($client->getAdresseComplement() != ""):?><?php echo $client->getAdresseComplement()?><br /><?php endif?>
					<?php echo $client->getCodePostal()?> <?php echo $client->getVille()?><br />
					<?php echo $client->getPays()?>
				</p>
			</td>
			<td>
				<p class="entete">Adresse de livraison</p>
				<p>
					<?php echo $commande->getCivilite()?> <?php echo $commande->getNom()?> <?php echo $commande->getPrenom()?><br />
					<?php echo $commande->getAdresse()?><br />
					<?php if($commande->getAdresseComplement() != ""):?><?php echo $commande->getAdresseComplement()?><br /><?php endif?>
					<?php echo $commande->getCodePostal()?> <?php echo $commande->getVille()?><br />
					<?php echo $commande->getPays()?>
				</p>
			</td>
		</tr>
		<?php if($commande->note_livraison != ""):?>
			<tr>
				<td colspan="2">
					<p class="entete">Note sur la livraison</p>
					<p><?php echo $commande->note_livraison ?></p>
				</td>
			</tr>
		<?php endif?>
	</table>
	<?php $panier = $sf_user->getAttribute('commande_articles');?>
	<?php if(sizeof($panier['nettoyeur']) > 0 && (substr($commande->getCodePostal(), 0, 2) == "97" || substr($commande->getCodePostal(), 0, 2) == "20")):?>
		<div id="commandeImpossible">Impossible de commander en ligne pour cette destination.<br/>Merci de <?php echo link_to("nous contacter", "@contact")?>.</div>
	<?php else:?>
		<?php 
			// Données concernant frais de ports
			$francoDePort = 0;
			$horsGabarit = 0;
			$totalPoids = 0;
			
			$totalProduitsHTTemp = 0;
			$totalProduitsHT = 0;
			$totalProduitsTTC = 0;
			$totalPortHT = 0;
			$totalHT = 0;
			$totalTVA = 0;
			$totalTTC = 0;
			$tva = Doctrine_Core::getTable("TauxTVA")->find(sfConfig::get('app_tva_196'));
		?>
		<table id="calculPanier">
			<tr class="entete">
				<td class="reference">Référence</td>
				<td class="designation">Désignation</td>
				<td class="voir">Voir</td>
				<td class="prixUnitHT">Prix<br />Unit. HT</td>
				<td class="quantite">Quantité</td>
				<td class="prixTotalHT">Prix<br />Total HT</td>
				<td class="prixTotalTTC">Prix<br />Total TTC</td>
			</tr>
			<?php foreach ($panier['article'] as $key => $commandeArticle):?>
				<?php $article = Doctrine::getTable("Article")->find($key)?>
				<tr class="lignePanier">
					<td><?php echo $key?></td>
					<td><?php echo $article->getDesignationCourte()?></td>
					<td><?php echo link_to("Voir", "@url_article?famille=".Utils::stringForUrl($article->getFamille()->getLibelle())."&reference_ths=".Utils::stringForUrl($article->getReferenceThs()), array("target" => "_blank"))?></td>
					<td class="affichageChiffre"><?php echo format_currency($article->getPrixVenteThs())?> €</td>
					<td class="affichageQte"><?php echo $commandeArticle->getQuantite()?></td>
					<td class="affichageChiffre"><?php echo format_currency($article->getPrixVenteThs() * $commandeArticle->getQuantite())?> €</td>
					<td class="affichageChiffre"><?php echo format_currency(Utils::prixAvecTVA($article->getPrixVenteThs() * $commandeArticle->getQuantite(), $tva->getTaux()))?> €</td>
				</tr>
				<?php 
					$totalProduitsHTTemp += $article->getPrixVenteThs() * $commandeArticle->getQuantite();
					$totalProduitsHT += $article->getPrixVenteThs() * $commandeArticle->getQuantite();
					$totalPoids += Utils::doubleFrToEn($article->getPoids()) * $commandeArticle->getQuantite();
					$totalTVA += $article->getPrixVenteThs() * $commandeArticle->getQuantite() * $tva->getTaux() / 100;
					
					if($article->getHorsGabarit())
					{
						$horsGabarit = 1;
					}
				?>
			<?php endforeach;?>
			<?php 
				$totalProduitsTTC += $totalProduitsHTTemp * (1 + $tva->getTaux() / 100);
				$totalProduitsHTTemp = 0;
			?>
			
			<?php foreach ($panier['nettoyeur'] as $key => $commandeArticle):?>
				<?php $nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($key)?>
				<tr class="lignePanier">
					<td><?php echo $nettoyeur->getReferenceThs()?></td>
					<td>Nettoyeur <?php echo $nettoyeur->getMarque()->getLibelle()?> <?php echo $nettoyeur->getModele()?></td>
					<td><?php echo link_to("Voir", "@url_nettoyeur?marque=".Utils::stringForUrl($nettoyeur->getMarque()->getLibelle())."&modele=".Utils::stringForUrl($nettoyeur->getModele()), array("target" => "_blank"))?></td>
					<td class="affichageChiffre"><?php echo format_currency($nettoyeur->getPrixVenteThs())?> €</td>
					<td class="affichageQte"><?php echo $commandeArticle->getQuantite()?></td>
					<td class="affichageChiffre"><?php echo format_currency($nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite())?> €</td>
					<td class="affichageChiffre"><?php echo format_currency(Utils::prixAvecTVA($nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite(), $tva->getTaux()))?> €</td>
				</tr>
				<?php 
					$totalProduitsHTTemp += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite();
					$totalProduitsHT += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite();
					$totalPoids += Utils::doubleFrToEn($nettoyeur->getPoids()) * $commandeArticle->getQuantite();
					$totalTVA += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite() * $tva->getTaux() / 100;
					
					if($nettoyeur->getFrancoDePort())
					{
						$francoDePort = 1;
					}
				?>
			<?php endforeach;?>
			<?php $totalProduitsTTC += $totalProduitsHTTemp * (1 + $tva->getTaux() / 100)?>
		</table>
		
		<div id="recalculPanierPort">
			<?php if($francoDePort):?>
				<p>Franco de port</p>
			<?php else:?>
				<?php 
					$tarif = ZoneTarifTable::calculFraisDePort($totalPoids * 1000, $horsGabarit, $client->getCodePostal());
					if(sizeof($tarif) > 0)
					{
						$tarif = $tarif[0];
					}
					$totalPortHT = $tarif->getZone()->getTransporteur()->getForfaitEmballage() + $tarif->getTarif();
					$totalTVA += $totalPortHT * $tva->getTaux() / 100;
				?>
				<table class="general">
					<tr>
						<td class="recalculerPanier"></td>
						<td class="infoFraisDePort">
							<p class="titre">Frais de port:</p>
						</td>
						<td class="fraisDePort">
							<table>
								<tr class="entete">
									<td>Poids Total</td>
									<td>Prix HT</td>
									<td>Prix TTC</td>
								</tr>
								<tr>
									<td class="affichageChiffre"><?php echo Utils::doubleEnToFr($totalPoids)?> kg</td>
									<td class="affichageChiffre"><?php echo format_currency($totalPortHT)?>€</td>
									<td class="affichageChiffre"><?php echo format_currency($totalPortHT * (1 + $tva->getTaux() / 100))?>€</td>
								</tr>
							</table>
						</td>
					</tr>
				</table>
			<?php endif?>
		</div>
		<?php 
			$totalPortTTC = Utils::prixAvecTVA($totalPortHT, $tva->getTaux());
			
			// Arrondi
			$totalProduitsTTC = round($totalProduitsTTC, 2);
			$totalPortTTC = round($totalPortTTC, 2);
			$totalTVA = round($totalTVA, 2);
			
			$totalHT = $totalProduitsHT + $totalPortHT;
			$totalTTC = $totalProduitsTTC + $totalPortTTC;
		?>
		<div id="validerPanier">
			<table class="general">
				<tr>
					<td class="recapitulatif">
						<table>
							<tr>
								<td class="texte">Total des produits HT</td>
								<td class="affichageChiffre"><?php echo format_currency($totalProduitsHT)?>€</td>
							</tr>
							<tr>
								<td class="texte">Total port HT</td>
								<td class="affichageChiffre"><?php echo format_currency($totalPortHT)?>€</td>
							</tr>
							<tr>
								<td colspan="2"></td>
							</tr>
							<tr>
								<td class="texte">Total HT</td>
								<td class="affichageChiffre"><?php echo format_currency($totalHT)?>€</td>
							</tr>
							<tr>
								<td class="texte">TVA <?php echo format_currency($tva->getTaux())?>%</td>
								<td class="affichageChiffre"><?php echo format_currency($totalTVA)?>€</td>
							</tr>
							<tr>
								<td colspan="2"></td>
							</tr>
							<tr>
								<td class="texte">Total TTC</td>
								<td class="texte affichageChiffre"><?php echo format_currency(round($totalTTC, 2))?>€</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</div>
		<?php echo link_to("PAYER", "@panier_paiement")?>
	<?php endif?>
</div>