<?php

/**
 * article module configuration.
 *
 * @package    ##PROJECT_NAME##
 * @subpackage article
 * @author     ##AUTHOR_NAME##
 * @version    SVN: $Id: configuration.php 24171 2009-11-19 16:37:50Z Kris.Wallsmith $
 */
abstract class BaseArticleGeneratorConfiguration extends sfModelGeneratorConfiguration
{
  public function getActionsDefault()
  {
    return array();
  }

  public function getFormActions()
  {
    return array(  '_delete' => NULL,  '_list' => NULL,  '_save' => NULL,  '_save_and_add' => NULL,);
  }

  public function getNewActions()
  {
    return array();
  }

  public function getEditActions()
  {
    return array();
  }

  public function getListObjectActions()
  {
    return array(  '_edit' => NULL,  '_delete' => NULL,);
  }

  public function getListActions()
  {
    return array(  '_new' => NULL,);
  }

  public function getListBatchActions()
  {
    return array(  '_delete' => NULL,);
  }

  public function getListParams()
  {
    return '%%=reference_ths%% - %%reference_ths_sage%% - %%prix_vente_ht%% - %%designation_courte%% - %%url_article%%';
  }

  public function getListLayout()
  {
    return 'tabular';
  }

  public function getListTitle()
  {
    return 'Liste des articles';
  }

  public function getEditTitle()
  {
    return 'Edition de l\'article';
  }

  public function getNewTitle()
  {
    return 'Nouvel article';
  }

  public function getFilterDisplay()
  {
    return array();
  }

  public function getFormDisplay()
  {
    return array();
  }

  public function getEditDisplay()
  {
    return array();
  }

  public function getNewDisplay()
  {
    return array();
  }

  public function getListDisplay()
  {
    return array(  0 => '=reference_ths',  1 => 'reference_ths_sage',  2 => 'prix_vente_ht',  3 => 'designation_courte',  4 => 'url_article',);
  }

  public function getFieldsDefault()
  {
    return array(
      'reference_ths' => array(  'is_link' => true,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'reference_ths_sage' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'ForeignKey',),
      'id_famille' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'ForeignKey',),
      'designation_courte' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'designation_detaillee' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'specificite' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'dimensions_a' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'dimensions_b' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'matiere' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'pression_maximum' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'temperature_maximum' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'diametre_nominal' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'reference_metrique_entree' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'sexe_entree' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'precision_supplementaire_entree' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'reference_metrique_sortie' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'sexe_sortie' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'precision_supplementaire_sortie' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'calibre_piece' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'debit_max' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'hors_gabarit' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Boolean',),
      'piece_origine' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Boolean',),
      'piece_visible' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Boolean',),
      'poids' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'prix_vente_ht' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'taux_remise_fournisseur' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'prix_vente_ths' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'marge_pourcentage' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'marge_euro' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'prix_ttc' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'stock' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'url_article' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'balise_title' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'balise_meta' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'minimum_commande' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Boolean',),
      'association_list' => array(  'is_link' => false,  'is_real' => false,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
    );
  }

  public function getFieldsList()
  {
    return array(
      'reference_ths' => array(),
      'reference_ths_sage' => array(),
      'id_famille' => array(),
      'designation_courte' => array(),
      'designation_detaillee' => array(),
      'specificite' => array(),
      'dimensions_a' => array(),
      'dimensions_b' => array(),
      'matiere' => array(),
      'pression_maximum' => array(),
      'temperature_maximum' => array(),
      'diametre_nominal' => array(),
      'reference_metrique_entree' => array(),
      'sexe_entree' => array(),
      'precision_supplementaire_entree' => array(),
      'reference_metrique_sortie' => array(),
      'sexe_sortie' => array(),
      'precision_supplementaire_sortie' => array(),
      'calibre_piece' => array(),
      'debit_max' => array(),
      'hors_gabarit' => array(),
      'piece_origine' => array(),
      'piece_visible' => array(),
      'poids' => array(),
      'prix_vente_ht' => array(),
      'taux_remise_fournisseur' => array(),
      'prix_vente_ths' => array(),
      'marge_pourcentage' => array(),
      'marge_euro' => array(),
      'prix_ttc' => array(),
      'stock' => array(),
      'url_article' => array(),
      'balise_title' => array(),
      'balise_meta' => array(),
      'minimum_commande' => array(),
      'association_list' => array(),
    );
  }

  public function getFieldsFilter()
  {
    return array(
      'reference_ths' => array(),
      'reference_ths_sage' => array(),
      'id_famille' => array(),
      'designation_courte' => array(),
      'designation_detaillee' => array(),
      'specificite' => array(),
      'dimensions_a' => array(),
      'dimensions_b' => array(),
      'matiere' => array(),
      'pression_maximum' => array(),
      'temperature_maximum' => array(),
      'diametre_nominal' => array(),
      'reference_metrique_entree' => array(),
      'sexe_entree' => array(),
      'precision_supplementaire_entree' => array(),
      'reference_metrique_sortie' => array(),
      'sexe_sortie' => array(),
      'precision_supplementaire_sortie' => array(),
      'calibre_piece' => array(),
      'debit_max' => array(),
      'hors_gabarit' => array(),
      'piece_origine' => array(),
      'piece_visible' => array(),
      'poids' => array(),
      'prix_vente_ht' => array(),
      'taux_remise_fournisseur' => array(),
      'prix_vente_ths' => array(),
      'marge_pourcentage' => array(),
      'marge_euro' => array(),
      'prix_ttc' => array(),
      'stock' => array(),
      'url_article' => array(),
      'balise_title' => array(),
      'balise_meta' => array(),
      'minimum_commande' => array(),
      'association_list' => array(),
    );
  }

  public function getFieldsForm()
  {
    return array(
      'reference_ths' => array(),
      'reference_ths_sage' => array(),
      'id_famille' => array(),
      'designation_courte' => array(),
      'designation_detaillee' => array(),
      'specificite' => array(),
      'dimensions_a' => array(),
      'dimensions_b' => array(),
      'matiere' => array(),
      'pression_maximum' => array(),
      'temperature_maximum' => array(),
      'diametre_nominal' => array(),
      'reference_metrique_entree' => array(),
      'sexe_entree' => array(),
      'precision_supplementaire_entree' => array(),
      'reference_metrique_sortie' => array(),
      'sexe_sortie' => array(),
      'precision_supplementaire_sortie' => array(),
      'calibre_piece' => array(),
      'debit_max' => array(),
      'hors_gabarit' => array(),
      'piece_origine' => array(),
      'piece_visible' => array(),
      'poids' => array(),
      'prix_vente_ht' => array(),
      'taux_remise_fournisseur' => array(),
      'prix_vente_ths' => array(),
      'marge_pourcentage' => array(),
      'marge_euro' => array(),
      'prix_ttc' => array(),
      'stock' => array(),
      'url_article' => array(),
      'balise_title' => array(),
      'balise_meta' => array(),
      'minimum_commande' => array(),
      'association_list' => array(),
    );
  }

  public function getFieldsEdit()
  {
    return array(
      'reference_ths' => array(),
      'reference_ths_sage' => array(),
      'id_famille' => array(),
      'designation_courte' => array(),
      'designation_detaillee' => array(),
      'specificite' => array(),
      'dimensions_a' => array(),
      'dimensions_b' => array(),
      'matiere' => array(),
      'pression_maximum' => array(),
      'temperature_maximum' => array(),
      'diametre_nominal' => array(),
      'reference_metrique_entree' => array(),
      'sexe_entree' => array(),
      'precision_supplementaire_entree' => array(),
      'reference_metrique_sortie' => array(),
      'sexe_sortie' => array(),
      'precision_supplementaire_sortie' => array(),
      'calibre_piece' => array(),
      'debit_max' => array(),
      'hors_gabarit' => array(),
      'piece_origine' => array(),
      'piece_visible' => array(),
      'poids' => array(),
      'prix_vente_ht' => array(),
      'taux_remise_fournisseur' => array(),
      'prix_vente_ths' => array(),
      'marge_pourcentage' => array(),
      'marge_euro' => array(),
      'prix_ttc' => array(),
      'stock' => array(),
      'url_article' => array(),
      'balise_title' => array(),
      'balise_meta' => array(),
      'minimum_commande' => array(),
      'association_list' => array(),
    );
  }

  public function getFieldsNew()
  {
    return array(
      'reference_ths' => array(),
      'reference_ths_sage' => array(),
      'id_famille' => array(),
      'designation_courte' => array(),
      'designation_detaillee' => array(),
      'specificite' => array(),
      'dimensions_a' => array(),
      'dimensions_b' => array(),
      'matiere' => array(),
      'pression_maximum' => array(),
      'temperature_maximum' => array(),
      'diametre_nominal' => array(),
      'reference_metrique_entree' => array(),
      'sexe_entree' => array(),
      'precision_supplementaire_entree' => array(),
      'reference_metrique_sortie' => array(),
      'sexe_sortie' => array(),
      'precision_supplementaire_sortie' => array(),
      'calibre_piece' => array(),
      'debit_max' => array(),
      'hors_gabarit' => array(),
      'piece_origine' => array(),
      'piece_visible' => array(),
      'poids' => array(),
      'prix_vente_ht' => array(),
      'taux_remise_fournisseur' => array(),
      'prix_vente_ths' => array(),
      'marge_pourcentage' => array(),
      'marge_euro' => array(),
      'prix_ttc' => array(),
      'stock' => array(),
      'url_article' => array(),
      'balise_title' => array(),
      'balise_meta' => array(),
      'minimum_commande' => array(),
      'association_list' => array(),
    );
  }


  /**
   * Gets the form class name.
   *
   * @return string The form class name
   */
  public function getFormClass()
  {
    return 'ArticleForm';
  }

  public function hasFilterForm()
  {
    return true;
  }

  /**
   * Gets the filter form class name
   *
   * @return string The filter form class name associated with this generator
   */
  public function getFilterFormClass()
  {
    return 'ArticleFormFilter';
  }

  public function getPagerClass()
  {
    return 'sfDoctrinePager';
  }

  public function getPagerMaxPerPage()
  {
    return 500;
  }

  public function getDefaultSort()
  {
    return array(null, null);
  }

  public function getTableMethod()
  {
    return '';
  }

  public function getTableCountMethod()
  {
    return '';
  }
}
