<?php

/**
 * commande module configuration.
 *
 * @package    ##PROJECT_NAME##
 * @subpackage commande
 * @author     ##AUTHOR_NAME##
 * @version    SVN: $Id: configuration.php 24171 2009-11-19 16:37:50Z Kris.Wallsmith $
 */
abstract class BaseCommandeGeneratorConfiguration extends sfModelGeneratorConfiguration
{
  public function getActionsDefault()
  {
    return array();
  }

  public function getFormActions()
  {
    return array(  '_delete' => NULL,  '_list' => NULL,  '_save' => NULL,  '_save_and_add' => NULL,);
  }

  public function getNewActions()
  {
    return array();
  }

  public function getEditActions()
  {
    return array();
  }

  public function getListObjectActions()
  {
    return array(  '_edit' => NULL,  '_delete' => NULL,);
  }

  public function getListActions()
  {
    return array(  '_new' => NULL,);
  }

  public function getListBatchActions()
  {
    return array(  '_delete' => NULL,);
  }

  public function getListParams()
  {
    return '%%=id_commande%% - %%total_ttc%% - %%id_statut%% - %%id_client%% - %%date_creation%% - %%date_edition%%';
  }

  public function getListLayout()
  {
    return 'tabular';
  }

  public function getListTitle()
  {
    return 'Liste des commandes';
  }

  public function getEditTitle()
  {
    return 'Edition de la commande';
  }

  public function getNewTitle()
  {
    return 'Nouvelle commande';
  }

  public function getFilterDisplay()
  {
    return array();
  }

  public function getFormDisplay()
  {
    return array();
  }

  public function getEditDisplay()
  {
    return array();
  }

  public function getNewDisplay()
  {
    return array();
  }

  public function getListDisplay()
  {
    return array(  0 => '=id_commande',  1 => 'total_ttc',  2 => 'id_statut',  3 => 'id_client',  4 => 'date_creation',  5 => 'date_edition',);
  }

  public function getFieldsDefault()
  {
    return array(
      'id_commande' => array(  'is_link' => true,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'poids_total' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'frais_port_ht' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'total_produit_ht' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'total_ht' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'taux_tva' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'total_ttc' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'id_statut' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'civilite' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'nom' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'prenom' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'adresse' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'adresse_complement' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'code_postal' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'ville' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'pays' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'telephone' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'fax' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'email' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'note_livraison' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'type_commande' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'commande_token' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'devis_token' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'devis_pdf' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'moyen_paiement' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'numero_transaction' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'numero_carte' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'certificat_transaction' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'date_transaction' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'id_client' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'ForeignKey',),
      'id_user_suiveur' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'ForeignKey',),
      'numero_colissimo' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'mail_commande' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Boolean',),
      'mail_colissimo' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Boolean',),
      'date_creation' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Date',),
      'date_edition' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Date',),
    );
  }

  public function getFieldsList()
  {
    return array(
      'id_commande' => array(),
      'poids_total' => array(),
      'frais_port_ht' => array(),
      'total_produit_ht' => array(),
      'total_ht' => array(),
      'taux_tva' => array(),
      'total_ttc' => array(),
      'id_statut' => array(),
      'civilite' => array(),
      'nom' => array(),
      'prenom' => array(),
      'adresse' => array(),
      'adresse_complement' => array(),
      'code_postal' => array(),
      'ville' => array(),
      'pays' => array(),
      'telephone' => array(),
      'fax' => array(),
      'email' => array(),
      'note_livraison' => array(),
      'type_commande' => array(),
      'commande_token' => array(),
      'devis_token' => array(),
      'devis_pdf' => array(),
      'moyen_paiement' => array(),
      'numero_transaction' => array(),
      'numero_carte' => array(),
      'certificat_transaction' => array(),
      'date_transaction' => array(),
      'id_client' => array(),
      'id_user_suiveur' => array(),
      'numero_colissimo' => array(),
      'mail_commande' => array(),
      'mail_colissimo' => array(),
      'date_creation' => array(),
      'date_edition' => array(),
    );
  }

  public function getFieldsFilter()
  {
    return array(
      'id_commande' => array(),
      'poids_total' => array(),
      'frais_port_ht' => array(),
      'total_produit_ht' => array(),
      'total_ht' => array(),
      'taux_tva' => array(),
      'total_ttc' => array(),
      'id_statut' => array(),
      'civilite' => array(),
      'nom' => array(),
      'prenom' => array(),
      'adresse' => array(),
      'adresse_complement' => array(),
      'code_postal' => array(),
      'ville' => array(),
      'pays' => array(),
      'telephone' => array(),
      'fax' => array(),
      'email' => array(),
      'note_livraison' => array(),
      'type_commande' => array(),
      'commande_token' => array(),
      'devis_token' => array(),
      'devis_pdf' => array(),
      'moyen_paiement' => array(),
      'numero_transaction' => array(),
      'numero_carte' => array(),
      'certificat_transaction' => array(),
      'date_transaction' => array(),
      'id_client' => array(),
      'id_user_suiveur' => array(),
      'numero_colissimo' => array(),
      'mail_commande' => array(),
      'mail_colissimo' => array(),
      'date_creation' => array(),
      'date_edition' => array(),
    );
  }

  public function getFieldsForm()
  {
    return array(
      'id_commande' => array(),
      'poids_total' => array(),
      'frais_port_ht' => array(),
      'total_produit_ht' => array(),
      'total_ht' => array(),
      'taux_tva' => array(),
      'total_ttc' => array(),
      'id_statut' => array(),
      'civilite' => array(),
      'nom' => array(),
      'prenom' => array(),
      'adresse' => array(),
      'adresse_complement' => array(),
      'code_postal' => array(),
      'ville' => array(),
      'pays' => array(),
      'telephone' => array(),
      'fax' => array(),
      'email' => array(),
      'note_livraison' => array(),
      'type_commande' => array(),
      'commande_token' => array(),
      'devis_token' => array(),
      'devis_pdf' => array(),
      'moyen_paiement' => array(),
      'numero_transaction' => array(),
      'numero_carte' => array(),
      'certificat_transaction' => array(),
      'date_transaction' => array(),
      'id_client' => array(),
      'id_user_suiveur' => array(),
      'numero_colissimo' => array(),
      'mail_commande' => array(),
      'mail_colissimo' => array(),
      'date_creation' => array(),
      'date_edition' => array(),
    );
  }

  public function getFieldsEdit()
  {
    return array(
      'id_commande' => array(),
      'poids_total' => array(),
      'frais_port_ht' => array(),
      'total_produit_ht' => array(),
      'total_ht' => array(),
      'taux_tva' => array(),
      'total_ttc' => array(),
      'id_statut' => array(),
      'civilite' => array(),
      'nom' => array(),
      'prenom' => array(),
      'adresse' => array(),
      'adresse_complement' => array(),
      'code_postal' => array(),
      'ville' => array(),
      'pays' => array(),
      'telephone' => array(),
      'fax' => array(),
      'email' => array(),
      'note_livraison' => array(),
      'type_commande' => array(),
      'commande_token' => array(),
      'devis_token' => array(),
      'devis_pdf' => array(),
      'moyen_paiement' => array(),
      'numero_transaction' => array(),
      'numero_carte' => array(),
      'certificat_transaction' => array(),
      'date_transaction' => array(),
      'id_client' => array(),
      'id_user_suiveur' => array(),
      'numero_colissimo' => array(),
      'mail_commande' => array(),
      'mail_colissimo' => array(),
      'date_creation' => array(),
      'date_edition' => array(),
    );
  }

  public function getFieldsNew()
  {
    return array(
      'id_commande' => array(),
      'poids_total' => array(),
      'frais_port_ht' => array(),
      'total_produit_ht' => array(),
      'total_ht' => array(),
      'taux_tva' => array(),
      'total_ttc' => array(),
      'id_statut' => array(),
      'civilite' => array(),
      'nom' => array(),
      'prenom' => array(),
      'adresse' => array(),
      'adresse_complement' => array(),
      'code_postal' => array(),
      'ville' => array(),
      'pays' => array(),
      'telephone' => array(),
      'fax' => array(),
      'email' => array(),
      'note_livraison' => array(),
      'type_commande' => array(),
      'commande_token' => array(),
      'devis_token' => array(),
      'devis_pdf' => array(),
      'moyen_paiement' => array(),
      'numero_transaction' => array(),
      'numero_carte' => array(),
      'certificat_transaction' => array(),
      'date_transaction' => array(),
      'id_client' => array(),
      'id_user_suiveur' => array(),
      'numero_colissimo' => array(),
      'mail_commande' => array(),
      'mail_colissimo' => array(),
      'date_creation' => array(),
      'date_edition' => array(),
    );
  }


  /**
   * Gets the form class name.
   *
   * @return string The form class name
   */
  public function getFormClass()
  {
    return 'CommandeForm';
  }

  public function hasFilterForm()
  {
    return true;
  }

  /**
   * Gets the filter form class name
   *
   * @return string The filter form class name associated with this generator
   */
  public function getFilterFormClass()
  {
    return 'CommandeFormFilter';
  }

  public function getPagerClass()
  {
    return 'sfDoctrinePager';
  }

  public function getPagerMaxPerPage()
  {
    return 100;
  }

  public function getDefaultSort()
  {
    return array('id_commande', 'desc');
  }

  public function getTableMethod()
  {
    return '';
  }

  public function getTableCountMethod()
  {
    return '';
  }
}
