ALTER TABLE `commande` ADD `moyen_paiement` SMALLINT NOT NULL AFTER `devis_pdf` ,
ADD `numero_transaction` VARCHAR( 255 ) NOT NULL AFTER `moyen_paiement` ;

CREATE TABLE configuration (id_configuration BIGINT AUTO_INCREMENT, libelle VARCHAR(255), valeur VARCHAR(255), actif TINYINT(1) DEFAULT '1' NOT NULL, PRIMARY KEY(id_configuration)) ENGINE = INNODB;

ALTER TABLE `association_article` ADD `ordre` SMALLINT NOT NULL ;

CREATE TABLE mail (id_mail BIGINT AUTO_INCREMENT, libelle VARCHAR(255), objet VARCHAR(255), mail text, fichier VARCHAR(255), PRIMARY KEY(id_mail)) ENGINE = INNODB;

ALTER TABLE `commande` ADD `commande_token` VARCHAR( 13 ) NOT NULL AFTER `note_livraison` ;

ALTER TABLE `commande` ADD `type_commande` TINYINT NOT NULL AFTER `note_livraison` ;

UPDATE commande c SET type_commande = 1 WHERE NOT EXISTS (SELECT * FROM commande_article a WHERE a.id_commande = c.id_commande);
UPDATE commande c SET type_commande = 2 WHERE EXISTS (SELECT * FROM commande_article a WHERE a.id_commande = c.id_commande);

CREATE TABLE mailing_pro (id_mailing_pro BIGINT AUTO_INCREMENT, civilite VARCHAR(10), nom VARCHAR(50), adresse VARCHAR(100), code_postal VARCHAR(10), ville VARCHAR(100), telephone VARCHAR(15), fax VARCHAR(15), gsm VARCHAR(15), activite VARCHAR(100), code_acces VARCHAR(100), date DATE, acces TINYINT(1), PRIMARY KEY(id_mailing_pro)) ENGINE = INNODB;
CREATE TABLE visite_pro (id_visite BIGINT AUTO_INCREMENT, id_mailing_pro BIGINT, url VARCHAR(255), date_heure_debut datetime, date_heure_fin datetime, INDEX id_mailing_pro_idx (id_mailing_pro), PRIMARY KEY(id_visite)) ENGINE = INNODB;
ALTER TABLE visite_pro ADD CONSTRAINT visite_pro_id_mailing_pro_mailing_pro_id_mailing_pro FOREIGN KEY (id_mailing_pro) REFERENCES mailing_pro(id_mailing_pro) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE `commande` ADD `numero_colissimo` VARCHAR( 13 ) NOT NULL AFTER `date_transaction` ;
ALTER TABLE `commande` ADD `mail_commande` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `numero_colissimo` ,
ADD `mail_colissimo` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `mail_commande` ;

CREATE TABLE backup_data (id_backup BIGINT AUTO_INCREMENT, date_time datetime, duration INT, PRIMARY KEY(id_backup)) ENGINE = INNODB;
CREATE TABLE backup_config (day BIGINT, PRIMARY KEY(day)) ENGINE = INNODB;


CREATE TABLE pressure_washer_price_history (id BIGINT AUTO_INCREMENT, date_time datetime, source text, price VARCHAR(255), id_pwww BIGINT, INDEX id_pwww_idx (id_pwww), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE pressure_washer_watch (id_nettoyeur BIGINT, price FLOAT(18, 2), PRIMARY KEY(id_nettoyeur)) ENGINE = INNODB;
CREATE TABLE pressure_washer_watch_website (id BIGINT AUTO_INCREMENT, name VARCHAR(255), url VARCHAR(255), before_price VARCHAR(255), after_price VARCHAR(255), id_nettoyeur BIGINT, INDEX id_nettoyeur_idx (id_nettoyeur), PRIMARY KEY(id)) ENGINE = INNODB;

ALTER TABLE pressure_washer_price_history ADD CONSTRAINT pipi FOREIGN KEY (id_pwww) REFERENCES pressure_washer_watch_website(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE pressure_washer_watch_website ADD CONSTRAINT pini_1 FOREIGN KEY (id_nettoyeur) REFERENCES nettoyeur_haute_pression(id_nettoyeur) ON UPDATE CASCADE ON DELETE CASCADE;

alter table article add minimum_commande TINYINT(1) DEFAULT '1' NOT NULL;

ALTER TABLE `client` ADD `adresse_complement` VARCHAR( 255 ) NOT NULL AFTER `adresse` ;
ALTER TABLE `commande` ADD `adresse_complement` VARCHAR( 255 ) NOT NULL AFTER `adresse` ;

ALTER TABLE `client` ADD `export_sage` TINYINT NOT NULL DEFAULT '0';
ALTER TABLE `backup_data` ADD `statut` TINYINT NOT NULL DEFAULT '0';