<?php

/**
 * Article filter form.
 *
 * @package    sf_sandbox
 * @subpackage filter
 * @author     Your name here
 * @version    SVN: $Id: sfDoctrineFormFilterTemplate.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class ArticleFormFilter extends BaseArticleFormFilter
{
	public function configure()
	{
		unset($this['reference_ths_sage'],
		$this['id_famille'],
		$this['designation_courte'],
		$this['designation_detaillee'],
		$this['specificite'],
		$this['dimensions_a'],
		$this['dimensions_b'],
		$this['matiere'],
		$this['pression_maximum'],
		$this['temperature_maximum'],
		$this['diametre_nominal'],
		$this['reference_metrique_entree'],
		$this['sexe_entree'],
		$this['precision_supplementaire_entree'],
		$this['reference_metrique_sortie'],
		$this['sexe_sortie'],
		$this['precision_supplementaire_sortie'],
		$this['calibre_piece'],
		$this['debit_max'],
		$this['hors_gabarit'],
		$this['piece_origine'],
		$this['piece_visible'],
		$this['poids'],
		$this['prix_vente_ht'],
		$this['taux_remise_fournisseur'],
		$this['prix_vente_ths'],
		$this['marge_pourcentage'],
		$this['marge_euro'],
		$this['prix_ttc'],
		$this['stock'],
		$this['url_article'],
		$this['balise_title'],
		$this['balise_meta'],
		$this['association_list']);

		$this->widgetSchema["reference_ths"] = new sfWidgetFormFilterInput();
		$this->validatorSchema["reference_ths"] = new sfValidatorPass(array('required' => false));

		$this->widgetSchema["reference_ths_sage"] = new sfWidgetFormFilterInput();
		$this->validatorSchema["reference_ths_sage"] = new sfValidatorPass(array('required' => false));

		$this->widgetSchema["id_famille"] = new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('Famille'), 'add_empty' => true));
		$this->validatorSchema["id_famille"] = new sfValidatorDoctrineChoice(array('required' => false, 'model' => $this->getRelatedModelName('Famille'), 'column' => 'id_famille'));
	}

	public function getFields()
	{
		return array(
      'reference_ths'                   => 'Text',
      'reference_ths_sage'              => 'Text',
      'id_famille'                      => 'ForeignKey',
      'designation_courte'              => 'Text',
      'designation_detaillee'           => 'Text',
      'specificite'                     => 'Text',
      'dimensions_a'                    => 'Text',
      'dimensions_b'                    => 'Text',
      'matiere'                         => 'Text',
      'pression_maximum'                => 'Text',
      'temperature_maximum'             => 'Text',
      'diametre_nominal'                => 'Text',
      'reference_metrique_entree'       => 'Text',
      'sexe_entree'                     => 'Text',
      'precision_supplementaire_entree' => 'Text',
      'reference_metrique_sortie'       => 'Text',
      'sexe_sortie'                     => 'Text',
      'precision_supplementaire_sortie' => 'Text',
      'calibre_piece'                   => 'Text',
      'debit_max'                       => 'Text',
      'hors_gabarit'                    => 'Boolean',
      'piece_origine'                   => 'Boolean',
      'piece_visible'                   => 'Boolean',
      'poids'                           => 'Text',
      'prix_vente_ht'                   => 'Number',
      'taux_remise_fournisseur'         => 'Number',
      'prix_vente_ths'                  => 'Number',
      'marge_pourcentage'               => 'Number',
      'marge_euro'                      => 'Number',
      'prix_ttc'                        => 'Number',
      'stock'                           => 'Number',
      'url_article'                     => 'Text',
      'balise_title'                    => 'Text',
      'balise_meta'                     => 'Text',
      'association_list'                => 'ManyKey',
		);
	}
}
