<?php
class PanierCoordonneesForm extends sfForm
{
	public function configure()
	{
		$this->setWidgets(array(
				'civilite'			=> new sfWidgetFormSelect(array("choices" =>array("Société" => "Société", "Mr" => "Mr", "Mme" => "Mme", "Melle" => "Melle"))),
				'nom'				=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'prenom'			=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'adresse'			=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 255)),
                                'adresse_complement'		=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 255)),
				'code_postal'                   => new sfWidgetFormInputText(array(), array('size'=> 5, 'maxlength' => 5)),
				'ville'				=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'pays'				=> new sfWidgetFormSelect(array("choices" =>array("France" => "France", "DOM" => "DOM", "Autre" => "Autre"))),
				'telephone'			=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 15)),
				'fax'				=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 15)),
				'id'				=> new sfWidgetFormInputHidden(),
				'email_address'                 => new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 155)),
				'email_confirmation'            => new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 155)),

				'livraison_civilite'            => new sfWidgetFormSelect(array("choices" =>array("Société" => "Société", "Mr" => "Mr", "Mme" => "Mme", "Melle" => "Melle"))),
				'livraison_nom'			=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'livraison_prenom'		=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'livraison_adresse'		=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 255)),
				'livraison_adresse_complement'	=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 255)),
				'livraison_code_postal'         => new sfWidgetFormInputText(array(), array('size'=> 5, 'maxlength' => 5)),
				'livraison_ville'		=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'livraison_pays'		=> new sfWidgetFormSelect(array("choices" =>array("France" => "France", "DOM" => "DOM", "Autre" => "Autre"))),
				'livraison_telephone'           => new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 15)),
				'livraison_fax'			=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 15)),

				'livraison_note'		=> new sfWidgetFormTextarea(),
		));
			
		$this->setValidators(array(
				'civilite'			=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre civilité')),
				'nom'				=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre nom')),
				'prenom'			=> new sfValidatorString(array('required' => false)),
				'adresse'			=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre adresse')),
				'adresse_complement'		=> new sfValidatorString(array('required' => false)),
				'code_postal'                   => new sfValidatorString(array('required' => true, 'min_length' => 5, 'max_length' => 5), array('required'=>'Veuillez renseigner le code postal')),
				'ville'				=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre ville')),
				'pays'				=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre pays')),
				'telephone'			=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre téléphone')),
				'fax'				=> new sfValidatorString(array('required' => false)),
				'id'				=> new sfValidatorString(array('required' => false)),
				'email_address'                 => new sfValidatorEmail(array('required' => true), array('required'=>'Veuillez renseigner votre email')),
				'email_confirmation'            => new sfValidatorEmail(array('required' => true), array('required'=>'Veuillez renseigner la confirmation de votre email')),

				'livraison_civilite'            => new sfValidatorString(array('required' => false)),
				'livraison_nom'			=> new sfValidatorString(array('required' => false)),
				'livraison_prenom'		=> new sfValidatorString(array('required' => false)),
				'livraison_adresse'		=> new sfValidatorString(array('required' => false)),
				'livraison_adresse_complement'	=> new sfValidatorString(array('required' => false)),
				'livraison_code_postal'         => new sfValidatorString(array('required' => false, 'min_length' => 5, 'max_length' => 5), array('required'=>'Veuillez renseigner le code postal')),
				'livraison_ville'		=> new sfValidatorString(array('required' => false)),
				'livraison_pays'		=> new sfValidatorString(array('required' => false)),
				'livraison_telephone'           => new sfValidatorString(array('required' => false)),
				'livraison_fax'			=> new sfValidatorString(array('required' => false)),

				'livraison_note'		=> new sfValidatorString(array('required' => false)),
		));
			
		$this->validatorSchema->setPostValidator(
		new sfValidatorAnd(array(
		new sfValidatorDoctrineUnique(array('model' => 'sfGuardUser', 'column' => 'email_address', 'primary_key' => 'id'), array('invalid'=>'Une adresse similaire est déjà enregistrée. Vous devez impérativement vous connecter en haut de ce formulaire.')),
		new sfValidatorSchemaCompare('email_address', sfValidatorSchemaCompare::EQUAL, 'email_confirmation', array(), array('invalid' => 'Les deux emails doivent être identiques')),
		new sfValidatorCallback(array('callback' => array($this, 'champsObligatoires')))
		))
		);

		$this->widgetSchema->setNameFormat('coordonnees[%s]');
	}

	public function champsObligatoires($validator, $values)
	{
		if($values["civilite"] != "Société" && $values["prenom"] == "")
		{
			$error = new sfValidatorError($validator, 'Veuillez renseigner votre prénom');
			// throw an error bound to the val field
			throw new sfValidatorErrorSchema($validator, array('prenom' => $error));
		}

		return $values;
	}
}