<?php

/**
 * Article form base class.
 *
 * @method Article getObject() Returns the current form's model object
 *
 * @package    sf_sandbox
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfDoctrineFormGeneratedTemplate.php 29553 2010-05-20 14:33:00Z Kris.Wallsmith $
 */
abstract class BaseArticleForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'reference_ths'                   => new sfWidgetFormInputHidden(),
      'reference_ths_sage'              => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('Association'), 'add_empty' => true)),
      'id_famille'                      => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('Famille'), 'add_empty' => true)),
      'designation_courte'              => new sfWidgetFormInputText(),
      'designation_detaillee'           => new sfWidgetFormInputText(),
      'specificite'                     => new sfWidgetFormInputText(),
      'dimensions_a'                    => new sfWidgetFormInputText(),
      'dimensions_b'                    => new sfWidgetFormInputText(),
      'matiere'                         => new sfWidgetFormInputText(),
      'pression_maximum'                => new sfWidgetFormInputText(),
      'temperature_maximum'             => new sfWidgetFormInputText(),
      'diametre_nominal'                => new sfWidgetFormInputText(),
      'reference_metrique_entree'       => new sfWidgetFormInputText(),
      'sexe_entree'                     => new sfWidgetFormInputText(),
      'precision_supplementaire_entree' => new sfWidgetFormInputText(),
      'reference_metrique_sortie'       => new sfWidgetFormInputText(),
      'sexe_sortie'                     => new sfWidgetFormInputText(),
      'precision_supplementaire_sortie' => new sfWidgetFormInputText(),
      'calibre_piece'                   => new sfWidgetFormInputText(),
      'debit_max'                       => new sfWidgetFormInputText(),
      'hors_gabarit'                    => new sfWidgetFormInputCheckbox(),
      'piece_origine'                   => new sfWidgetFormInputCheckbox(),
      'piece_visible'                   => new sfWidgetFormInputCheckbox(),
      'poids'                           => new sfWidgetFormInputText(),
      'prix_vente_ht'                   => new sfWidgetFormInputText(),
      'taux_remise_fournisseur'         => new sfWidgetFormInputText(),
      'prix_vente_ths'                  => new sfWidgetFormInputText(),
      'marge_pourcentage'               => new sfWidgetFormInputText(),
      'marge_euro'                      => new sfWidgetFormInputText(),
      'prix_ttc'                        => new sfWidgetFormInputText(),
      'stock'                           => new sfWidgetFormInputText(),
      'url_article'                     => new sfWidgetFormInputText(),
      'balise_title'                    => new sfWidgetFormInputText(),
      'balise_meta'                     => new sfWidgetFormInputText(),
      'minimum_commande'                => new sfWidgetFormInputCheckbox(),
      'association_list'                => new sfWidgetFormDoctrineChoice(array('multiple' => true, 'model' => 'Association')),
    ));

    $this->setValidators(array(
      'reference_ths'                   => new sfValidatorChoice(array('choices' => array($this->getObject()->get('reference_ths')), 'empty_value' => $this->getObject()->get('reference_ths'), 'required' => false)),
      'reference_ths_sage'              => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('Association'), 'required' => false)),
      'id_famille'                      => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('Famille'), 'required' => false)),
      'designation_courte'              => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'designation_detaillee'           => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'specificite'                     => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'dimensions_a'                    => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'dimensions_b'                    => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'matiere'                         => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'pression_maximum'                => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'temperature_maximum'             => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'diametre_nominal'                => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'reference_metrique_entree'       => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'sexe_entree'                     => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'precision_supplementaire_entree' => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'reference_metrique_sortie'       => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'sexe_sortie'                     => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'precision_supplementaire_sortie' => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'calibre_piece'                   => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'debit_max'                       => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'hors_gabarit'                    => new sfValidatorBoolean(array('required' => false)),
      'piece_origine'                   => new sfValidatorBoolean(array('required' => false)),
      'piece_visible'                   => new sfValidatorBoolean(array('required' => false)),
      'poids'                           => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'prix_vente_ht'                   => new sfValidatorNumber(array('required' => false)),
      'taux_remise_fournisseur'         => new sfValidatorNumber(array('required' => false)),
      'prix_vente_ths'                  => new sfValidatorNumber(array('required' => false)),
      'marge_pourcentage'               => new sfValidatorNumber(array('required' => false)),
      'marge_euro'                      => new sfValidatorNumber(array('required' => false)),
      'prix_ttc'                        => new sfValidatorNumber(array('required' => false)),
      'stock'                           => new sfValidatorInteger(array('required' => false)),
      'url_article'                     => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'balise_title'                    => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'balise_meta'                     => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'minimum_commande'                => new sfValidatorBoolean(array('required' => false)),
      'association_list'                => new sfValidatorDoctrineChoice(array('multiple' => true, 'model' => 'Association', 'required' => false)),
    ));

    $this->validatorSchema->setPostValidator(
      new sfValidatorDoctrineUnique(array('model' => 'Article', 'column' => array('reference_ths_sage')))
    );

    $this->widgetSchema->setNameFormat('article[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    $this->setupInheritance();

    parent::setup();
  }

  public function getModelName()
  {
    return 'Article';
  }

  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['association_list']))
    {
      $this->setDefault('association_list', $this->object->Association->getPrimaryKeys());
    }

  }

  protected function doSave($con = null)
  {
    $this->saveAssociationList($con);

    parent::doSave($con);
  }

  public function saveAssociationList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['association_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (null === $con)
    {
      $con = $this->getConnection();
    }

    $existing = $this->object->Association->getPrimaryKeys();
    $values = $this->getValue('association_list');
    if (!is_array($values))
    {
      $values = array();
    }

    $unlink = array_diff($existing, $values);
    if (count($unlink))
    {
      $this->object->unlink('Association', array_values($unlink));
    }

    $link = array_diff($values, $existing);
    if (count($link))
    {
      $this->object->link('Association', array_values($link));
    }
  }

}
