<?php

/**
 * Association form base class.
 *
 * @method Association getObject() Returns the current form's model object
 *
 * @package    sf_sandbox
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfDoctrineFormGeneratedTemplate.php 29553 2010-05-20 14:33:00Z Kris.Wallsmith $
 */
abstract class BaseAssociationForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'id_association' => new sfWidgetFormInputHidden(),
      'ordre'          => new sfWidgetFormInputText(),
      'texte'          => new sfWidgetFormInputText(),
      'note'           => new sfWidgetFormInputText(),
      'id_famille'     => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('Famille'), 'add_empty' => false)),
      'id_nettoyeur'   => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('NettoyeurHautePression'), 'add_empty' => false)),
      'articles_list'  => new sfWidgetFormDoctrineChoice(array('multiple' => true, 'model' => 'Article')),
    ));

    $this->setValidators(array(
      'id_association' => new sfValidatorChoice(array('choices' => array($this->getObject()->get('id_association')), 'empty_value' => $this->getObject()->get('id_association'), 'required' => false)),
      'ordre'          => new sfValidatorInteger(array('required' => false)),
      'texte'          => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'note'           => new sfValidatorString(array('max_length' => 100, 'required' => false)),
      'id_famille'     => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('Famille'))),
      'id_nettoyeur'   => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('NettoyeurHautePression'))),
      'articles_list'  => new sfValidatorDoctrineChoice(array('multiple' => true, 'model' => 'Article', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('association[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    $this->setupInheritance();

    parent::setup();
  }

  public function getModelName()
  {
    return 'Association';
  }

  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['articles_list']))
    {
      $this->setDefault('articles_list', $this->object->Articles->getPrimaryKeys());
    }

  }

  protected function doSave($con = null)
  {
    $this->saveArticlesList($con);

    parent::doSave($con);
  }

  public function saveArticlesList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['articles_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (null === $con)
    {
      $con = $this->getConnection();
    }

    $existing = $this->object->Articles->getPrimaryKeys();
    $values = $this->getValue('articles_list');
    if (!is_array($values))
    {
      $values = array();
    }

    $unlink = array_diff($existing, $values);
    if (count($unlink))
    {
      $this->object->unlink('Articles', array_values($unlink));
    }

    $link = array_diff($values, $existing);
    if (count($link))
    {
      $this->object->link('Articles', array_values($link));
    }
  }

}
