<?php

/**
 * Zone form base class.
 *
 * @method Zone getObject() Returns the current form's model object
 *
 * @package    sf_sandbox
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfDoctrineFormGeneratedTemplate.php 29553 2010-05-20 14:33:00Z Kris.Wallsmith $
 */
abstract class BaseZoneForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'id_zone'           => new sfWidgetFormInputHidden(),
      'libelle'           => new sfWidgetFormInputText(),
      'statut'            => new sfWidgetFormInputCheckbox(),
      'id_transporteur'   => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('Transporteur'), 'add_empty' => false)),
      'departements_list' => new sfWidgetFormDoctrineChoice(array('multiple' => true, 'model' => 'Departement')),
    ));

    $this->setValidators(array(
      'id_zone'           => new sfValidatorChoice(array('choices' => array($this->getObject()->get('id_zone')), 'empty_value' => $this->getObject()->get('id_zone'), 'required' => false)),
      'libelle'           => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'statut'            => new sfValidatorBoolean(array('required' => false)),
      'id_transporteur'   => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('Transporteur'))),
      'departements_list' => new sfValidatorDoctrineChoice(array('multiple' => true, 'model' => 'Departement', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('zone[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    $this->setupInheritance();

    parent::setup();
  }

  public function getModelName()
  {
    return 'Zone';
  }

  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['departements_list']))
    {
      $this->setDefault('departements_list', $this->object->Departements->getPrimaryKeys());
    }

  }

  protected function doSave($con = null)
  {
    $this->saveDepartementsList($con);

    parent::doSave($con);
  }

  public function saveDepartementsList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['departements_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (null === $con)
    {
      $con = $this->getConnection();
    }

    $existing = $this->object->Departements->getPrimaryKeys();
    $values = $this->getValue('departements_list');
    if (!is_array($values))
    {
      $values = array();
    }

    $unlink = array_diff($existing, $values);
    if (count($unlink))
    {
      $this->object->unlink('Departements', array_values($unlink));
    }

    $link = array_diff($values, $existing);
    if (count($link))
    {
      $this->object->link('Departements', array_values($link));
    }
  }

}
