<?php

/**
 * ArticleTable
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class ArticleTable extends Doctrine_Table
{
    /**
     * Returns an instance of this class.
     *
     * @return object ArticleTable
     */
    public static function getInstance()
    {
        return Doctrine_Core::getTable('Article');
    }
    
    /**
     * Récupère la liste des articles (reference_ths et reference_ths_sage) pour la fonction d'import
     * Enter description here ...
     * @param unknown_type $listeReferenceTHS
     */
	public static function recupererListeArticlePourImport($listeReferenceTHS)
    {
    	$sql = self::getInstance()
    					->createQuery("a")
    					->select("a.reference_ths, a.reference_ths_sage")
    					->andWhereIn("a.reference_ths", $listeReferenceTHS);
    	
    	return $sql->execute();
    }
    
	public static function supprimerArticle($listeArticle)
    {
    	$sql = self::getInstance()
    					->createQuery("a")
    					->delete()
    					->andWhereIn("a.reference_ths", $listeArticle);
    	
    	return $sql->execute();
    }
    
	public static function getArticleByFamilleReferenceTHSFromUrl($famille, $reference_ths)
    {
    	$recherche = "%".$famille."/".$reference_ths.".html";
    	$result = Doctrine_Query::create()
    			->from("Article a")
    			->where("a.url_article LIKE ?", $recherche)
    			->execute();
    
    	if(sizeof($result) > 0)
    	{
    		return $result[0];
    	}
    	else
    	{
    		return false;
    	}
    }
}