<?php

/**
 * FamilleTable
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class FamilleTable extends Doctrine_Table
{
	/**
	 * Returns an instance of this class.
	 *
	 * @return object FamilleTable
	 */
	public static function getInstance()
	{
		return Doctrine_Core::getTable('Famille');
	}

	/**
	 * Récupère la liste des familles d'articles
	 * @param $statut
	 */
	public static function recupererListeArticleFamille($statut = '')
	{
		$sql = self::getInstance()
					->createQuery("f");
		if($statut != '')
		{
			$sql->andWhere("f.statut = ?", $statut);
		}
		$sql->orderBy("f.ordre ASC");
		 
		return $sql->execute();
	}

	public static function recupererListeArticleFamilleEnTableau($statut = '')
	{
		$resultat = self::recupererListeArticleFamille($statut);
		$res = array();
		foreach($resultat as $objet)
		{
			$res[strtolower($objet->libelle)] = $objet->id_famille;
		}
		return $res;
	}
	
	public static function existeLibelle($id_famille, $libelle)
	{
		$resultat = Doctrine::getTable("Famille")
						->createQuery("f")
						->where("LOWER(f.libelle) = ?", strtolower($libelle))
						->andWhere("f.id_famille != ?", $id_famille)
						->execute();
		if(sizeof($resultat) > 0)
		{
			return true;
		}
		return false;
	}
	
	public static function existeOrdre($id_famille, $ordre)
	{
		$resultat = Doctrine::getTable("Famille")
						->createQuery("f")
						->where("f.ordre = ?", $ordre)
						->andWhere("f.id_famille != ?", $id_famille)
						->execute();
		if(sizeof($resultat) > 0)
		{
			return true;
		}
		return false;
	}
}