<?php

/**
 * ZoneTarifTable
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class ZoneTarifTable extends Doctrine_Table
{
    /**
     * Returns an instance of this class.
     *
     * @return object ZoneTarifTable
     */
    public static function getInstance()
    {
        return Doctrine_Core::getTable('ZoneTarif');
    }
    
	/**
	 * Calcul le frais de port en fonction du poids, du gabarit et du code postal
	 * @param $poids : en gramme
	 * @param $hors_gabarit: oui / non
	 * @param $code_postal : 75000
	 * @Return array
	 */
	public static function calculFraisDePort($poids, $hors_gabarit, $code_postal)
	{
		$departement = substr($code_postal, 0, 2);
		
		// Cas pour la corse
		if($departement == "20")
		{
			$departement = "2A";
		}
		
		// Cas pour les DOM TOM
		if($departement == "97")
		{
			$departement = substr($code_postal, 0, 3);
		}
		
		$q = Doctrine_Query::create()
					->from('ZoneTarif t')
					->innerJoin('t.Zone z')
					->innerJoin('z.ZoneDepartement d')
					->innerJoin('t.Poids p')
					->innerJoin('z.Transporteur r')
					->where('d.id_departement = ?', $departement)
					->andWhere('p.poids >= ?', PoidsTable::getIdPoidsByPoids($poids)->getPoids());
					
		if($hors_gabarit || (!$hors_gabarit && $poids > 10000))
		{
			// Requête pour les colis hors gabarit
			$q->andWhere('r.hors_gabarit = true');
			
		}
		
		$res = $q->orderBy("p.poids ASC")
					->groupBy("r.id_transporteur")
					->execute();
		
		if(sizeof($res) <= 1)
		{
			return $res;
		}

		// Trie en fonction du prix
		foreach($res as $tarif)
		{
			$prix = $tarif->getZone()->getTransporteur()->getForfaitEmballage() + $tarif->getTarif();
			$resultat[] = $prix;
		}
		
		// Trie en fonction du prix
		foreach($res as $tarif)
		{
			$resultat_bis[] = $tarif;
		}

		array_multisort($resultat, $resultat_bis);
		
		/**
		 * EXCEPTION : si département = 24 ou en gabarit, le premier doit toujours être La Poste
		 */
		if($departement == 24 || (!$hors_gabarit && $poids < 10000))
		{
			$id = null;
			for($i = 0; $i < sizeof($resultat_bis); $i++)
			{
				if($resultat_bis[$i]->getZone()->getTransporteur()->getIdTransporteur() == sfConfig::get('app_la_poste_id'))
				{
					$id = $i;
					break;
				}
			}
			
			if(!is_null($id))
			{
				$resultat = array();
				$resultat[] = $resultat_bis[$id];
				foreach($resultat_bis as $key => $tarif)
				{
					if($key != $id)
					{
						$resultat[] = $tarif;
					}
				}
				$resultat_bis = $resultat;
			}
		}
		/**
		 * FIN EXCEPTION
		 */
		
		return $resultat_bis;
	}
}